// AppFrame.cpp : CAppFrame ʵ
//

#include "stdafx.h"
#include "App.h"
#include "AppSettings.h"
#include "AppGlobals.h"
#include "AppFrame.h"
#include "MyEditView.h"
#include "DlgPrint.h"
#include "DlgAbout.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

/////////////////////////////////////////////////////////////////////////////
// CAppFrame
IMPLEMENT_DYNAMIC(CAppFrame, CMDIFrameWnd)
BEGIN_MESSAGE_MAP(CAppFrame, CMDIFrameWnd)
        ON_WM_CREATE()
        ON_WM_SYSCOLORCHANGE()
        ON_UPDATE_COMMAND_UI(ID_FILE_NEW,         OnUpdateGroupFile)
        ON_UPDATE_COMMAND_UI(ID_FILE_OPEN,        OnUpdateGroupFile)
        ON_UPDATE_COMMAND_UI(ID_FILE_SAVE_ALL,    OnUpdateGroupFile)
        ON_UPDATE_COMMAND_UI(ID_FILE_PRINT_ALL,   OnUpdateGroupFile)
        ON_UPDATE_COMMAND_UI(ID_FILE_PRINT_SETUP, OnUpdateGroupFile)
        ON_UPDATE_COMMAND_UI(ID_WINDOW_CLOSE_ALL, OnUpdateGroupWindow)
        ON_UPDATE_COMMAND_UI(ID_HELP,             OnUpdateGroupHelp)
        ON_UPDATE_COMMAND_UI(ID_HELP_ABOUT,       OnUpdateGroupHelp)
        ON_COMMAND(ID_FILE_NEW,                   OnGroupFile)
        ON_COMMAND(ID_FILE_OPEN,                  OnGroupFile)
        ON_COMMAND(ID_FILE_SAVE_ALL,              OnGroupFile)
        ON_COMMAND(ID_FILE_PRINT_ALL,             OnGroupFile)
        ON_COMMAND(ID_FILE_PRINT_SETUP,           OnGroupFile)
        ON_COMMAND(ID_WINDOW_CLOSE_ALL,           OnGroupWindow)
        ON_COMMAND(ID_HELP,                       OnGroupHelp)
        ON_COMMAND(ID_HELP_ABOUT,                 OnGroupHelp)
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// CAppFrame /
CAppFrame::CAppFrame()
{
        // TODO: ڴӳԱʼ
        // Ҫ
        appData.SetAppFrame(this);
}

CAppFrame::~CAppFrame()
{
        appData.SetAppFrame(NULL);
}


BOOL CAppFrame::PreCreateWindow(CREATESTRUCT& cs)
{
        if (!CMDIFrameWnd::PreCreateWindow(cs))
        {
                return false;
        }

        // TODO: ڴ˴ͨ޸ CREATESTRUCT cs ޸Ĵ
        // ʽ

        return true;
}

/////////////////////////////////////////////////////////////////////////////
// CAppFrame 
#ifdef _DEBUG
void CAppFrame::AssertValid() const
{
        CMDIFrameWnd::AssertValid();
}

void CAppFrame::Dump(CDumpContext& dc) const
{
        CMDIFrameWnd::Dump(dc);
}

#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CAppFrame Ϣ
int CAppFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
        if (CMDIFrameWnd::OnCreate(lpCreateStruct) == -1)
        {
                return -1;
        }

        static UINT indicators[] =
        {
                ID_SEPARATOR,                  // 
                        ID_INDICATOR_CURRENT_POSITION, // ǰ༭λá
                        ID_INDICATOR_CURRENT_CHAR,     // ǰַ
                        ID_INDICATOR_DOC_SIZE,         // ĵѡС
                        ID_INDICATOR_FILE_FORMAT,      // зͣת͡
                        ID_INDICATOR_OVERRIDE,         // INSERTǷ¡
                        ID_INDICATOR_READ_ONLY,        // Ƿֻ
        };

        if (!m_wndStatusBar.Create(this)
                || !m_wndStatusBar.SetIndicators(indicators, SIZEOF(indicators)))
        {
                TRACE0("״̬ʧܣ\n");
                return -1;
        }
        m_wndStatusBar.GetStatusBarCtrl().SetSimple(false);

        if (!m_wndToolBar.CreateEx(this,
                TBSTYLE_FLAT,
                WS_CHILD | WS_VISIBLE | CBRS_TOP |
                CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC))
        {
                TRACE0("δܴ\n");
                return -1;      // δܴ
        }
        ToolBarInit();

        // TODO: Ҫͣɾ
        //m_wndToolBar.EnableDocking(CBRS_ALIGN_ANY);
        //EnableDocking(CBRS_ALIGN_ANY);
        //DockControlBar(&m_wndToolBar);

        // ñ༭ؼõ壬κʱٴá
        //CPfxEditView::SetFont((HFONT)::GetStockObject(DEFAULT_GUI_FONT));
        static CFont s_font;
        s_font.CreatePointFont(90, _T("Courier New"));
        CPfxEditView::SetFont(s_font);

        return 0;
}

/////////////////////////////////////////////////////////////////////////////
// ToolBar...
BOOL CAppFrame::ToolBarInit()
{
        static const CToolBarInit tbi[] =
        {
                {ID_FILE_NEW,           IMAGE_TBB_NEW,          0},
                {ID_FILE_OPEN,          IMAGE_TBB_OPEN,         0},
                {ID_FILE_SAVE,          IMAGE_TBB_SAVE,         0},
                {ID_FILE_SAVE_ALL,      IMAGE_TBB_SAVE_ALL,     0},
                {0,                     -1,                     0},
                {ID_FILE_PRINT_PREVIEW, IMAGE_TBB_PRIVIEW,      0},
                {ID_FILE_PRINT,         IMAGE_TBB_PRINT,        0},
                {0,                     -1,                     0},
                {ID_EDIT_UNDO,          IMAGE_TBB_UNDO,         0},
                {ID_EDIT_REDO,          IMAGE_TBB_REDO,         0},
                {0,                     -1,                     0},
                {ID_EDIT_CLEAR,         IMAGE_TBB_CLEAR,        0},
                {ID_EDIT_CUT,           IMAGE_TBB_CUT,          0},
                {ID_EDIT_COPY,          IMAGE_TBB_COPY,         0},
                {ID_EDIT_PASTE,         IMAGE_TBB_PASTE,        0},
                {0,                     -1,                     0},
                {ID_SEARCH_FIND,        IMAGE_TBB_FIND,         0},
                {ID_SEARCH_REPLACE,     IMAGE_TBB_REPLACE,      0},
                {0,                     -1,                     0},
                {ID_SEARCH_TOGGLE_BOOKMARK,     IMAGE_TBB_TOGGLE_BOOKMARK,      0},
                {ID_SEARCH_NEXT_BOOKMARK,       IMAGE_TBB_NEXT_BOOKMARK,        0},
                {ID_SEARCH_PREV_BOOKMARK,       IMAGE_TBB_PREV_BOOKMARK,        0},
                {ID_SEARCH_CLEAR_ALL_BOOKMARKS, IMAGE_TBB_CLEAR_ALL_BOOKMARKS,  0},
                {0,                     -1,                     0},
                {ID_WINDOW_CASCADE,     IMAGE_TBB_WINDOW_CASCADE,       0},
                {ID_WINDOW_TILE_HORZ,   IMAGE_TBB_WINDOW_TILE_HORZ,     0},
                {ID_WINDOW_TILE_VERT,   IMAGE_TBB_WINDOW_TILE_VERT,     0},
                {0,                     -1,                     0},
                {ID_VIEW_LINE_NUMBER,   IMAGE_TBB_VIEW_LINE_NUMBER,     0},
                {ID_VIEW_RULER,         IMAGE_TBB_VIEW_RULER,           0},
                {ID_VIEW_LINE_BREAK,    IMAGE_TBB_VIEW_LINE_BREAK,      0},
                {ID_VIEW_WHITE_SPACE,   IMAGE_TBB_VIEW_WHITE_SPACE,     0},
                {ID_EDIT_SET_WORD_WRAP, IMAGE_TBB_WORD_WRAP,    0},
        };
        return ToolBarSetButtons(m_wndToolBar, tbi, SIZEOF(tbi));
}


BOOL CAppFrame::ToolBarSetButtons(CBarTool& wndBar, const CToolBarInit* ptbi, int ntbi)
{
        CToolBarCtrl& tbc = wndBar.GetToolBarCtrl();
        wndBar.SetSizes(appData.sizeTBButton(), appData.sizeBarImage());

        TBBUTTON tbb[256];
        memset(tbb, 0, sizeof(tbb));

        ASSERT(ptbi != NULL);
        ASSERT((ntbi > 0) && (ntbi < SIZEOF(tbb)));

        for (int i = 0; i < ntbi; i++)
        {
                const CToolBarInit& tbi = ptbi[i];
                tbb[i].iString   = -1;
                tbb[i].iBitmap   = -1;
                tbb[i].fsStyle   = TBSTYLE_SEP;
                tbb[i].fsState   = TBSTATE_ENABLED;
                tbb[i].idCommand = tbi.nCmd;

                if (tbi.nCmd == 0)
                {
                        continue;
                }

                TCHAR sz[MAX_PATH];
                memset(sz, 0, sizeof(sz));
                AfxLoadString(tbi.nString, sz, SIZEOF(sz));

                tbb[i].iString = tbc.SendMessage(TB_ADDSTRING, 0, (LPARAM)sz);
                tbb[i].iBitmap = tbi.nImage;
                tbb[i].fsStyle = TBSTYLE_BUTTON | TBSTYLE_AUTOSIZE;
        }

        tbc.AddButtons(ntbi, tbb);
        tbc.SetImageList(CImageList::FromHandle(appData.ImageListToolbar()));

        return true;
}

/////////////////////////////////////////////////////////////////////////////
// TextEdit...
CMyEditView* CAppFrame::TextEditGetActiveView() const
{
        ASSERT_VALID(this);

        CMDIChildWnd* pChildWnd = MDIGetActive();
        if (pChildWnd != NULL)
        {
                CView* pView = pChildWnd->GetActiveView();
                if ((pView != NULL)
                        && pView->IsKindOf(RUNTIME_CLASS(CMyEditView)))
                {
                        return static_cast<CMyEditView*>(pView);
                }
        }
        return NULL;
}

CMyEditDoc* CAppFrame::TextEditGetActiveDoc() const
{
        CMyEditView* pTextEditView = TextEditGetActiveView();
        if (pTextEditView != NULL)
        {
                return static_cast<CMyEditDoc*> \
                        (pTextEditView->GetDocument());
        }
        return NULL;
}

// ǰ༭ѡݣͻȡв(nBufMax-1)ַı
// ͨڡҡ滻Իĳʼ
int CAppFrame::TextEditGetSingleLineSelContent(LPTSTR pBuffer, int nBufMax)
{
        if ((pBuffer == NULL) || (nBufMax < 1))
        {
                return 0;
        }

        LONG nCharsCopied = 0;

        CMyEditView* pView = TextEditGetActiveView();
        if ((pView != NULL)
                && pView->IsTextSelected()
                && !pView->IsColumnSelect())
        {
                memset(pBuffer, 0, (nBufMax * sizeof(TCHAR)));

                nBufMax--; // NULLַ

                CPoint ptFrom;
                CPoint ptTo;

                pView->GetSelRange(ptFrom, ptTo);

                // nSelSizeʵʵѡGetSelData()ֻʵʵ
                // ѡݣ򷵻صһеݡ
                nCharsCopied = (pView->GetLineLength(ptFrom.y) - ptFrom.x + 1);
                nCharsCopied = min(nCharsCopied, nBufMax);
                nCharsCopied = pView->GetSelData(PFX_EC_LINE_BREAK_TYPE_DOS, pBuffer, nCharsCopied);
        }
        return nCharsCopied;
}

CMyEditDoc* CAppFrame::TextEditOpenDocument(LPCTSTR pszFileName, LONG nFileConverter)
{
        ASSERT((nFileConverter == PFX_EC_FILE_CONVERTER_AUTO_DETECT)
                || (nFileConverter == PFX_EC_FILE_CONVERTER_ANSI)
                || (nFileConverter == PFX_EC_FILE_CONVERTER_UTF8)
                || (nFileConverter == PFX_EC_FILE_CONVERTER_UNICODE)
                || (nFileConverter == PFX_EC_FILE_CONVERTER_UNICODE_BIG_ENDIAN));

        CMyEditDoc* pDoc = NULL;
        m_dataTextEdit.nFileConverter = nFileConverter;

        try
        {
                pDoc = static_cast<CMyEditDoc*>(GetApp()->OpenDocumentFile(pszFileName));
        }
        catch (CException* e)
        {
                e->Delete();
        }

        m_dataTextEdit.nFileConverter = PFX_EC_FILE_CONVERTER_AUTO_DETECT;
        return pDoc;
}

CMyEditDoc* CAppFrame::TextEditCreateNewDocument()
{
        CDocument* pDocument = NULL;
        CMultiDocTemplate* pDocTemplate = GetApp()->DocGetTextEditTemplate();
        if (pDocTemplate != NULL)
        {
                pDocument = pDocTemplate->OpenDocumentFile(NULL, true);
        }
        return static_cast<CMyEditDoc*>(pDocument);
}

void CAppFrame::TextEditUpdateAllDocuments(BOOL bRecalcLayout)
{
        // ûѴĵõʾ塣
        const CMultiDocTemplate* pDocTemplate = GetApp()->DocGetTextEditTemplate();
        POSITION posDocument = pDocTemplate->GetFirstDocPosition();
        while (posDocument != NULL)
        {
                CMyEditDoc* pDocument = static_cast<CMyEditDoc*> \
                        (pDocTemplate->GetNextDoc(posDocument));
                pDocument->UpdateAllViews(bRecalcLayout);
        }
}

void CAppFrame::TextEditUpdateFont(CFont& font)
{
        HFONT hFont = (HFONT)font.GetSafeHandle();
        if (CMyEditView::GetFont() != hFont)
        {
                CMyEditView::SetFont(hFont);
                TextEditUpdateAllDocuments(true);
        }
}

void CAppFrame::TextEditUpdateSpacingLines(int nSpacing)
{
        ASSERT(nSpacing >= 0);

        if (CMyEditView::GetSpacingLines() != nSpacing)
        {
                CMyEditView::SetSpacingLines(nSpacing);
                TextEditUpdateAllDocuments(false);
        }
}

void CAppFrame::TextEditUpdateSpacingLineNumberAndText(int nSpacing)
{
        ASSERT(nSpacing >= 0);

        if (CMyEditView::GetSpacingLineNumberAndText() != nSpacing)
        {
                CMyEditView::SetSpacingLineNumberAndText(nSpacing);
                TextEditUpdateAllDocuments(true);
        }
}

void CAppFrame::TextEditSetTitle(CMyEditDoc* pDocument, LPCTSTR pszTitle)
{
        if ((pDocument == NULL) || (pszTitle == NULL) || (*pszTitle == '\0'))
        {
                return;
        }

        pDocument->SetTitle(pszTitle);
}

// ȡǰ༭ڵUNDO, REDOûеǰ༭ȱʡġ
// ָ䡣
void CAppFrame::TextEditGetUndoRedoName(BOOL bUndo, LPTSTR pBuffer, int nBufMax)
{
        if ((pBuffer == NULL) || (nBufMax <= 0))
        {
                return;
        }

        memset(pBuffer, 0, nBufMax * sizeof(TCHAR));

        CMyEditView* pTextEditView = TextEditGetActiveView();
        if (pTextEditView == NULL)
        {
                AfxLoadString((bUndo ? IDS_UNDO_NAME : IDS_REDO_NAME),
                        pBuffer,
                        nBufMax);
                return;
        }

        struct CAppMainFrameUndoRedoName
        {
                INT            nIDName;
                UINT           nIDUndoString;
                UINT           nIDRedoString;
        };

        static const CAppMainFrameUndoRedoName l_name[] =
        {
                {PFX_EC_UNDO_UNKNOWN,                 IDS_UNDO_UNKNOWN,                       IDS_REDO_UNKNOWN},
                {PFX_EC_UNDO_TYPING,                  IDS_UNDO_TYPING,                        IDS_REDO_TYPING},
                {PFX_EC_UNDO_REMOVE,                  IDS_UNDO_REMOVE,                        IDS_REDO_REMOVE},
                {PFX_EC_UNDO_INSERT,                  IDS_UNDO_INSERT,                        IDS_REDO_INSERT},
                {PFX_EC_UNDO_CUT,                     IDS_UNDO_CUT,                           IDS_REDO_CUT},
                {PFX_EC_UNDO_PASTE,                   IDS_UNDO_PASTE,                         IDS_REDO_PASTE},
                {PFX_EC_UNDO_REPLACE,                 IDS_UNDO_REPLACE,                       IDS_REDO_REPLACE},
                {PFX_EC_UNDO_REPLACE_ALL,             IDS_UNDO_REPLACE_ALL,                   IDS_REDO_REPLACE_ALL},
                {PFX_EC_UNDO_DRAGDROP_COPY,           IDS_UNDO_DRAGDROP_COPY,                 IDS_REDO_DRAGDROP_COPY},
                {PFX_EC_UNDO_DRAGDROP_MOVE,           IDS_UNDO_DRAGDROP_MOVE,                 IDS_REDO_DRAGDROP_MOVE},
                {PFX_EC_UNDO_SPACES_TO_TABS,          IDS_UNDO_SPACES_TO_TABS,                IDS_REDO_SPACES_TO_TABS},
                {PFX_EC_UNDO_SPACES_TO_TABS_LEADING,  IDS_UNDO_SPACES_TO_TABS_LEADING,        IDS_REDO_SPACES_TO_TABS_LEADING},
                {PFX_EC_UNDO_TABS_TO_SPACES,          IDS_UNDO_TABS_TO_SPACES,                IDS_REDO_TABS_TO_SPACES},
                {PFX_EC_UNDO_TRIM_TRAILING_SPACES,    IDS_UNDO_TRIM_TRAILING_SPACES,          IDS_REDO_TRIM_TRAILING_SPACES},
                {PFX_EC_UNDO_CASE_LOWER,              IDS_UNDO_CASE_LOWER,                    IDS_REDO_CASE_LOWER},
                {PFX_EC_UNDO_CASE_UPPER,              IDS_UNDO_CASE_UPPER,                    IDS_REDO_CASE_UPPER},
                {PFX_EC_UNDO_CASE_INVERT,             IDS_UNDO_CASE_INVERT,                   IDS_REDO_CASE_INVERT},
                {PFX_EC_UNDO_CASE_CAPITALIZE,         IDS_UNDO_CASE_CAPITALIZE,               IDS_REDO_CASE_CAPITALIZE},
        };

        int nIDName;
        UINT nIDString;

        if (bUndo)
        {
                nIDName   = pTextEditView->GetUndoName();
                nIDString = IDS_UNDO_UNKNOWN;
        }
        else
        {
                nIDName   = pTextEditView->GetRedoName();
                nIDString = IDS_REDO_UNKNOWN;
        }

        for (int i = 0; i < SIZEOF(l_name); i++)
        {
                if (l_name[i].nIDName == nIDName)
                {
                        if (bUndo)
                        {
                                nIDString = l_name[i].nIDUndoString;
                        }
                        else
                        {
                                nIDString = l_name[i].nIDRedoString;
                        }
                        break;
                }
        }

        AfxLoadString(nIDString, pBuffer, nBufMax);
}

void CAppFrame::TextEditPrintInitial(CMyEditView* pView)
{
        CDlgPrint pd(pView);
        pd.DoModal();
}

/////////////////////////////////////////////////////////////////////////////
// ...
UINT CAppFrame::GetCurrentCommand() const
{
        ASSERT_VALID(this);

        // #define GET_WM_COMMAND_ID(wParam, lParam) LOWORD(wp)
        return static_cast<UINT>(LOWORD(GetCurrentMessage()->wParam));
}

UINT CAppFrame::CreateShortcutMenu(CWnd* pWndOwner, CMenu* pMenu, CPoint point)
{
        if ((pMenu == NULL) || (pWndOwner == NULL))
        {
                return 0;
        }

        CRect rect;
        pWndOwner->GetWindowRect(&rect);
        if (!rect.PtInRect(point))
        {
                pWndOwner->GetClientRect(&rect);
                pWndOwner->ClientToScreen(&rect);
                point.x = rect.left;
                point.y = rect.top;
        }

        WORD wCmd = static_cast<WORD>(pMenu->TrackPopupMenu(TPM_LEFTALIGN | 
                TPM_LEFTBUTTON | TPM_RIGHTBUTTON | TPM_RETURNCMD,
                point.x,
                point.y,
                pWndOwner,
                NULL));

        if (wCmd != 0) // ʾûȡ
        {
                pWndOwner->SendMessage(WM_COMMAND,
                        MAKEWPARAM(wCmd, 0),
                        (LPARAM)(pWndOwner->GetSafeHwnd()));
        }
        return (UINT)wCmd;
}
/////////////////////////////////////////////////////////////////////////////
// OnFile..
void CAppFrame::OnUpdateGroupFile(CCmdUI* pCmdUI)
{
        BOOL bOn;
        switch (pCmdUI->m_nID)
        {
        case ID_FILE_NEW:
        case ID_FILE_OPEN:
        case ID_FILE_PRINT_SETUP:
                bOn = true;
                break;

        case ID_FILE_SAVE_ALL:
        case ID_FILE_PRINT_ALL:
                bOn = (MDIGetActive() != NULL);
                break;

        default:
                bOn = false;
                break;
        }
        pCmdUI->Enable(bOn);
}

void CAppFrame::OnGroupFile()
{
        // TODO: ڴ˴Ϣ
        switch (GetCurrentCommand())
        {
        case ID_FILE_NEW:
                OnCmdFileNew();
                break;

        case ID_FILE_OPEN:
                OnCmdFileOpen();
                break;

        case ID_FILE_SAVE_ALL:
                OnCmdFileSaveAll();
                break;

        case ID_FILE_PRINT_ALL:
                OnCmdFilePrintAll();
                break;

        case ID_FILE_PRINT_SETUP:
                OnCmdFilePrintSetup();
                break;
        }
}

void CAppFrame::OnCmdFileOpen() 
{
        // TODO: ڴ˴Ϣ
        CAppSettings* pAppSettings = GetAppSettings();
        LPCTSTR pszFilter = pAppSettings->FileFilterGetList();

        CFileDialog fd(true,
                NULL,
                NULL,
                OFN_EXPLORER | OFN_ALLOWMULTISELECT | OFN_ENABLESIZING |
                OFN_FILEMUSTEXIST | OFN_HIDEREADONLY,
                pszFilter,
                this);

        try
        {
                if (fd.DoModal() == IDOK)
                {
                        POSITION pos = fd.GetStartPosition();
                        while (pos != NULL)
                        {
                                TextEditOpenDocument(fd.GetNextPathName(pos));
                        }
                }
        }
        catch (CException* e)
        {
                TCHAR sz[MAX_PATH];
                e->GetErrorMessage(sz, SIZEOF(sz));
                appAlert1(sz, MB_OK | MB_ICONERROR);
                e->Delete();
        }
}

void CAppFrame::OnCmdFilePrintSetup()
{
        TextEditPrintInitial(NULL);
}

void CAppFrame::OnCmdFilePrintAll() // ʾӡԻֱӴӡ
{
        // TODO: ڴ˴Ϣ
        const CMultiDocTemplate* pTemplate = GetApp()->DocGetTextEditTemplate();

        POSITION posDocument = pTemplate->GetFirstDocPosition();
        while (posDocument != NULL)
        {
                CDocument* pDocument = pTemplate->GetNextDoc(posDocument);
                if (pDocument->IsKindOf(RUNTIME_CLASS(CMyEditDoc)))
                {
                        POSITION posView = pDocument->GetFirstViewPosition();
                        while (posView != NULL)
                        {
                                CView* pView = pDocument->GetNextView(posView);
                                if (pView->IsKindOf(RUNTIME_CLASS(CMyEditView)))
                                {
                                        pView->SendMessage(
                                                WM_COMMAND,
                                                ID_FILE_PRINT_DIRECT);
                                        break; // пǴӡԤͼ
                                }
                        }
                }
        }
}

/////////////////////////////////////////////////////////////////////////////
// OnWindow...
void CAppFrame::OnUpdateGroupWindow(CCmdUI* pCmdUI)
{
        BOOL bOn;
        switch (pCmdUI->m_nID)
        {
        case ID_WINDOW_CLOSE_ALL:
                bOn = (MDIGetActive() != NULL);
                break;
        default:
                bOn = false;
                break;
        }
        pCmdUI->Enable(bOn);
}

void CAppFrame::OnGroupWindow()
{
        // TODO: ڴ˴Ϣ
        switch (GetCurrentCommand())
        {
        case ID_WINDOW_CLOSE_ALL:
                OnCmdWindowCloseAll();
                break;
        }
}
/////////////////////////////////////////////////////////////////////////////
// OnHelp...
void CAppFrame::OnUpdateGroupHelp(CCmdUI* pCmdUI)
{
        pCmdUI->Enable(true);
}

void CAppFrame::OnGroupHelp() 
{
        // TODO: ڴ˴Ϣ
        switch (GetCurrentCommand())
        {
        case ID_HELP:
                OnCmdHelp();
                break;

        case ID_HELP_ABOUT:
                OnCmdHelpAbout();
                break;
        default:
                break;
        }
}

void CAppFrame::OnCmdHelpAbout()
{
        CDlgAbout dlg;
        dlg.DoModal();
}
