// AppFrame.h : CAppFrame Ľӿ
//
#pragma once

#include "App.h"
#include "AppGlobals.h"
#include "BarTool.h"
#include "BarStatus.h"
#include "MyEditView.h"
#include "MyEditDoc.h"

/////////////////////////////////////////////////////////////////////////////
// class CAppFrame
class CAppFrame : public CMDIFrameWnd
{
	DECLARE_DYNAMIC(CAppFrame)
public:
	CAppFrame();

public:
        UINT           GetCurrentCommand() const; // ̲ͬ߳ʹá
        UINT           CreateShortcutMenu(CWnd* pwndOwner, CMenu* pMenu, CPoint point);

        /////////////////////////////////////////////////////////////////////
        // ༭ؼ...
public:
        struct CDataTextEdit
        {
                LONG           nFileConverter;

        public:
                CDataTextEdit()
                {
                        nFileConverter = PFX_EC_FILE_CONVERTER_AUTO_DETECT;
                }
        };
        CDataTextEdit  m_dataTextEdit;

        int            TextEditGetSingleLineSelContent(LPTSTR pBuffer, int nBufMax);
        CMyEditDoc*    TextEditGetActiveDoc() const;
        CMyEditView*   TextEditGetActiveView() const;
        CMyEditDoc*    TextEditCreateNewDocument();
        
        void           TextEditUpdateFont(CFont& font);
        void           TextEditUpdateSpacingLines(int nSpacing);
        void           TextEditUpdateSpacingLineNumberAndText(int nSpacing);
        void           TextEditUpdateAllDocuments(BOOL bRecalcLayout);
        void           TextEditGetUndoRedoName(BOOL bUndo, LPTSTR pBuffer, int nBufMax);
        
        // ͬʱĵͳĿơ
        void           TextEditSetTitle(CMyEditDoc* pDocument, LPCTSTR pszTitle);

        // MFCDOC/VIEWƺĵSerialize()֮ǰӴ
        // ĵָ룬޷ĵװļʱָļݵĽ뷽
        // ⲿʶCMyEditDocPreload() ļݵĽ
        // FEC_AUTO_DETECT, FEC_ANSI, FEC_UTF8, FEC_UNICODEȣ
        CMyEditDoc*    TextEditOpenDocument(LPCTSTR pszFileName, LONG nFileConverter = PFX_EC_FILE_CONVERTER_AUTO_DETECT);
        void           TextEditPrintInitial(CMyEditView* pView);
// 
public:

// 
public:
        struct CToolBarInit
        {
                int            nCmd;
                int            nImage;
                int            nString;
        };
        BOOL           ToolBarInit();
        BOOL           ToolBarSetButtons(CBarTool& wndBar, const CToolBarInit* ptbi, int ntbi);

// д
public:
	virtual BOOL   PreCreateWindow(CREATESTRUCT& cs);

// ʵ
public:
	virtual        ~CAppFrame();

#ifdef _DEBUG
	virtual void   AssertValid() const;
	virtual void   Dump(CDumpContext& dc) const;
#endif

protected:  // ؼǶԱ
        CBarTool       m_wndToolBar;
        CBarStatus     m_wndStatusBar;

protected:
        void           OnCmdFileNew();
        void           OnCmdFileOpen();
        void           OnCmdFileSaveAll();
        void           OnCmdFilePrintAll();
        void           OnCmdFilePrintSetup();

        void           OnCmdViewToolBar();
        void           OnCmdViewStatusBar();

        void           OnCmdWindowCloseAll();

        void           OnCmdHelp();
        void           OnCmdHelpAbout();

// ɵϢӳ亯
protected:
	DECLARE_MESSAGE_MAP()
	afx_msg int    OnCreate(LPCREATESTRUCT lpCreateStruct);
        afx_msg void   OnGroupFile();
        afx_msg void   OnGroupWindow();
        afx_msg void   OnGroupHelp();
        afx_msg void   OnUpdateGroupFile(CCmdUI* pCmdUI);
        afx_msg void   OnUpdateGroupWindow(CCmdUI* pCmdUI);
        afx_msg void   OnUpdateGroupHelp(CCmdUI* pCmdUI);
};

inline void            CAppFrame::OnCmdFileNew()        { TextEditCreateNewDocument(); }
inline void            CAppFrame::OnCmdFileSaveAll()    { GetApp()->DocSaveAllModifiedNoPrompt(); }
inline void            CAppFrame::OnCmdWindowCloseAll() { if (GetApp()->SaveAllModified()) { GetApp()->CloseAllDocuments(false); }}
inline void            CAppFrame::OnCmdHelp()           { }
