#include "stdafx.h"
#include <strsafe.h>
#include "App.h"
#include "AppGlobals.h"
#include "AppFrame.h"

/////////////////////////////////////////////////////////////////////////////
#pragma comment(lib, "shlwapi.lib")

/////////////////////////////////////////////////////////////////////////////
// CAppData
CAppData appData;

/////////////////////////////////////////////////////////////////////////////
CAppData::CAppData()
{
        memset(&m_dataApp,  0, sizeof(m_dataApp));
        memset(&m_dataRsrc, 0, sizeof(m_dataRsrc));
}

CAppData::~CAppData()
{
        // ɾӰԴ
        HIMAGELIST hImageList[6] =
        {
                m_dataRsrc.hImlToolbar,
                        m_dataRsrc.hImlGlobals,
        };

        int i;
        for (i = 0; i < SIZEOF(hImageList); i++)
        {
                if (hImageList[i] != NULL)
                {
                        ::ImageList_Destroy(hImageList[i]);
                }
        }

        HFONT hFont[3] =
        {
                m_dataRsrc.hFontH1,
                        m_dataRsrc.hFontH2,
                        m_dataRsrc.hFontForm,
        };
        for (i = 0; i < SIZEOF(hFont); i++)
        {
                if (hFont[i] != NULL)
                {
                        ::DeleteObject(hFont[i]);
                }
        }
}

void CAppData::Initialize()
{
        m_dataRsrc.sizeAppImage.cx = NUM_CX_APP_IMAGE;
        m_dataRsrc.sizeAppImage.cy = NUM_CY_APP_IMAGE;
        m_dataRsrc.sizeBarImage.cx = NUM_CX_BAR_IMAGE;
        m_dataRsrc.sizeBarImage.cy = NUM_CY_BAR_IMAGE;
        m_dataRsrc.sizeDlgImage.cx = NUM_CX_DLG_IMAGE;
        m_dataRsrc.sizeDlgImage.cy = NUM_CY_DLG_IMAGE;

        // ťĸ߶ҪݵʱϵͳĽĸ߶Ⱥͼĸ߶ȡ
        // ֮еֵΪϵͳܻǡ塱ǡԶ塱ȡ
        CSize sizeBtn;
        sizeBtn.cx = m_dataRsrc.sizeBarImage.cx;
        //sizeBtn.cy = max(m_dataRsrc.sizeBarImage.cy, pfxData.FontToolMetrics().tmHeight);
        sizeBtn.cy = m_dataRsrc.sizeBarImage.cy;
        m_dataRsrc.sizeTBButton = sizeBtn + CSize(7, 6);
        
        struct CImageListInit
        {
                UINT           nID;
                HIMAGELIST*    phImageList;
                CSize*         pSize;
        };

        CImageListInit imlInit[] =
        {
                {IDB_TOOLBAR, &m_dataRsrc.hImlToolbar, &m_dataRsrc.sizeBarImage},
                {IDB_GLOBALS, &m_dataRsrc.hImlGlobals, &m_dataRsrc.sizeAppImage},
        };

        for (int i = 0; i < SIZEOF(imlInit); i++)
        {
                CBitmap bmp;
                bmp.LoadBitmap(imlInit[i].nID);
                if (*imlInit[i].phImageList != NULL)
                {
                        ::ImageList_Destroy(*imlInit[i].phImageList);
                }
                CSize size = *imlInit[i].pSize;
                *imlInit[i].phImageList = ::ImageList_Create(size.cx,
                        size.cy,
                        ILC_COLOR32 | ILC_MASK,
                        0,
                        0);
                ::ImageList_AddMasked(*imlInit[i].phImageList, (HBITMAP)bmp, CLR_MASK);
        }

        struct CFontInit
        {
                HFONT*         phFont;
                int            nScale;
                int            nWeight;
        };

        CFontInit fontForm[] =
        {
                {&m_dataRsrc.hFontH1,   180, FW_BOLD},
                {&m_dataRsrc.hFontH2,   120, FW_BOLD},
                {&m_dataRsrc.hFontForm, 100, FW_NORMAL},
        };

        CFont fontDef;
        fontDef.CreateStockObject(DEFAULT_GUI_FONT);
        
        LOGFONT lfDef;
        fontDef.GetLogFont(&lfDef);

        for (int i = 0; i < SIZEOF(fontForm); i++)
        {
                LOGFONT lf;
                memcpy(&lf, &lfDef, sizeof(LOGFONT));
                lf.lfWidth  = 0;
                lf.lfHeight = lf.lfHeight * fontForm[i].nScale / 100;
                lf.lfWeight = fontForm[i].nWeight;
                
                HFONT* phFont = fontForm[i].phFont;
                if (*phFont != NULL)
                {
                        ::DeleteObject(*phFont);
                        *phFont = NULL;
                }
                *phFont = ::CreateFontIndirect(&lf);
        }
}

/////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////
int CGlobals::appAlert1(LPCTSTR pszText, UINT nType)
{
        // ޸ĴϢӳȡ
        HWND hWndFocus = ::GetFocus();
        int nResponse = AfxMessageBox(pszText, nType);
        if (::IsChild(AfxGetMainWnd()->GetSafeHwnd(), hWndFocus))
        {
                ::SetFocus(hWndFocus);
        }
        return nResponse;
}

int CGlobals::appAlert1(UINT nID, UINT nType)
{
        CString string;
        string.LoadString(nID);
        return appAlert1((LPCTSTR)string, nType);
}

int __cdecl CGlobals::appAlert2(UINT nID, UINT nType, ...)
{
        CString strFormat;
        CString strMessage;

        va_list arglist;
        va_start(arglist, nType);

        strFormat.LoadString(nID);
        strMessage.FormatV(strFormat, arglist);

        va_end(arglist);

        return appAlert1((LPCTSTR)strMessage, nType);
}
/////////////////////////////////////////////////////////////////////////////
// :
// :
//     ĲֵǷȡ
// :
// :
// ע:
/////////////////////////////////////////////////////////////////////////////
BOOL CGlobals::appIsEqualBool(BOOL b1, BOOL b2)
{
        return (b1 && b2) || (!b1 && !b2);
}
/////////////////////////////////////////////////////////////////////////////
// :
// :
// :
// :
// ע:
/////////////////////////////////////////////////////////////////////////////
void CGlobals::appGlobalFree(HGLOBAL hGlobal)
{
        if ((hGlobal == NULL)
                || (GlobalFlags(hGlobal) == GMEM_INVALID_HANDLE))
        {
                return;
        }
        
        // avoid bogus warning error messages from various debugging tools
        UINT nCount = GlobalFlags(hGlobal) & GMEM_LOCKCOUNT;
        while (nCount--)
        {
                GlobalUnlock(hGlobal);
        }
        
        // finally, really free the handle
        GlobalFree(hGlobal);
}
/////////////////////////////////////////////////////////////////////////////
// :
// :
// :
// :
// ע:
/////////////////////////////////////////////////////////////////////////////
INT_PTR CGlobals::appGetMsgString(UINT nID, LPTSTR pszBuf, INT_PTR cch)
{
        cch = AfxLoadString(nID, pszBuf, (UINT)cch);
        if (cch != 0)
        {
                LPTSTR lp = _tcschr(pszBuf, '\n');
                if (lp != NULL)
                {
                        *lp = '\0';
                        cch = lp - pszBuf;
                }
        }
        return cch;
}
/////////////////////////////////////////////////////////////////////////////
// :
// :
// :
// :
// ע:
/////////////////////////////////////////////////////////////////////////////
INT_PTR CGlobals::appGetToolTipString(UINT nID, LPTSTR pszBuf, INT_PTR cch)
{
        cch = AfxLoadString(nID, pszBuf, (UINT)cch);
        if (cch != 0)
        {
                LPTSTR lp = _tcsrchr(pszBuf, '\n');
                if (lp != NULL)
                {
                        lp++;
                        cch -= (lp - pszBuf);
                        memmove(pszBuf, lp, (cch + 1) * sizeof(TCHAR));
                }
        }
        return cch;
}

void CGlobals::appGetSysErrMsg(DWORD dwMsgID, CString& strOut)
{
        LPTSTR pszMessage = strOut.GetBuffer(MAX_PATH);
        *pszMessage = '\0';
        
        ::FormatMessage(FORMAT_MESSAGE_FROM_SYSTEM | FORMAT_MESSAGE_IGNORE_INSERTS,
                NULL,
                dwMsgID,
                MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT),
                pszMessage,
                MAX_PATH,
                NULL);
        
        strOut.ReleaseBuffer();
}

/////////////////////////////////////////////////////////////////////////////
BOOL _cdecl CGlobals::strPrintf(LPTSTR pszDst, int cchDst, UINT nIdFormat, ...)
{
        if ((pszDst == NULL) || (cchDst <= 0))
        {
                return false;
        }

        va_list argList;
        va_start(argList, nIdFormat);

        TCHAR szBufferT[512];
        AfxLoadString(nIdFormat,
                szBufferT,
                SIZEOF(szBufferT));
        
        HRESULT hr = StringCchVPrintf(pszDst,
                cchDst,
                szBufferT,
                argList);
        
        va_end(argList);
        return (hr == S_OK);
}

BOOL _cdecl CGlobals::strPrintf(LPTSTR pszDst, int cchDst, LPCTSTR pszFormat, ...)
{
        if ((pszDst == NULL) || (cchDst <= 0) || (pszFormat == NULL))
        {
                return false;
        }

        va_list argList;
        va_start(argList, pszFormat);

        HRESULT hr = StringCchVPrintf(pszDst, cchDst, pszFormat, argList);
        
        va_end(argList);
        return (hr == S_OK);
}

void CGlobals::strCat(LPTSTR pszDst, int cchDst, LPCTSTR pszSrc)
{
        if ((pszDst == NULL) || (cchDst <= 0) || (pszSrc == NULL))
        {
                return;
        }
        StringCchCat(pszDst, cchDst, pszSrc);
}

void CGlobals::strCpy(LPTSTR pszDst, int cchDst, LPCTSTR pszSrc)
{
        if ((pszDst == NULL) || (cchDst <= 0) || (pszSrc == NULL))
        {
                return;
        }
        StringCchCopy(pszDst, cchDst, pszSrc);
}

void CGlobals::strCpyN(LPTSTR pszDst, int cchDst, LPCTSTR pszSrc, int cchSrc)
{
        StringCchCopyN(pszDst, cchDst, pszSrc, cchSrc);
}

int CGlobals::strLen(LPCTSTR psz)
{
        if (psz == NULL)
        {
                return 0;
        }
        return lstrlen(psz);
}

LPTSTR CGlobals::strInc(LPCTSTR psz)
{
        if (psz == NULL)
        {
                return NULL;
        }
        return _tcsinc(psz);
}

LPTSTR CGlobals::strChr(LPCTSTR psz, int ch)
{
        if (psz == NULL)
        {
                return NULL;
        }
        return (LPTSTR)_tcschr(psz, (_TINT)ch);
}

LPTSTR CGlobals::strRChr(LPCTSTR psz, int ch)
{
        if (psz == NULL)
        {
                return NULL;
        }
        return (LPTSTR)_tcsrchr(psz, (_TINT)ch);
}

int CGlobals::strCmp(LPCTSTR psz1, LPCTSTR psz2)
{
        if ((psz1 == NULL) || (psz2 == NULL))
        {
                return 0;
        }
        return _tcscmp(psz1, psz2);
}

/////////////////////////////////////////////////////////////////////////////
// жһ·ǷΪĿ¼µġ...Ŀ¼
BOOL CGlobals::pathIsDots(LPCTSTR pszPathName)
{
	if (pszPathName != NULL)
	{
                LPCTSTR s0 = pszPathName;
                LPCTSTR s1 = pszPathName + 1;
                LPCTSTR s2 = pszPathName + 2;
		
		if (*s0 == '.')
		{
			if ((*s1 == '\0') || ((*s1 == '.') && (*s2 == '\0')))
			{
                                return true;
			}
		}
	}
        return false;
}

// Ƿָļڡ
BOOL CGlobals::pathIsFileExists(LPTSTR pszPathName)
{
        ASSERT(AfxIsValidString(pszPathName));

        ::PathRemoveBlanks(pszPathName);
        ::PathRemoveBackslash(pszPathName);
        return (::PathFileExists(pszPathName) || ::PathIsUNC(pszPathName));
}

// Ƿָ·ڡ
BOOL CGlobals::pathIsPathExists(LPTSTR pszPathName)
{
        ASSERT(AfxIsValidString(pszPathName));

        ::PathRemoveBlanks(pszPathName);
        ::PathRemoveBackslash(pszPathName);
        return (::PathIsDirectory(pszPathName) || ::PathIsUNC(pszPathName));
}

LPCTSTR CGlobals::pathGetFileExt(LPCTSTR pszPathName)
{
        ASSERT(AfxIsValidString(pszPathName));
        return ::PathFindExtension(pszPathName);
}

UINT CGlobals::pathGetFileName(LPCTSTR pszPathName, LPTSTR pszBuffer/*MAX_PATH*/)
{
        ASSERT(AfxIsValidString(pszPathName));
        ASSERT(pszBuffer != NULL && AfxIsValidAddress(pszBuffer, MAX_PATH));

        _tcsncpy(pszBuffer, ::PathFindFileName(pszPathName), MAX_PATH);
        return static_cast<UINT>(_tcslen(pszBuffer));
}

UINT CGlobals::pathGetDirName(LPCTSTR pszPathName, LPTSTR pszBuffer/*MAX_PATH*/)
{
        ASSERT(AfxIsValidString(pszPathName));
        ASSERT(pszBuffer != NULL && AfxIsValidAddress(pszBuffer, MAX_PATH));

        _tcsncpy(pszBuffer, pszPathName, MAX_PATH);
        ::PathRemoveFileSpec(pszBuffer);
        return static_cast<UINT>(_tcslen(pszBuffer));
}

UINT CGlobals::pathGetFullPathName(LPCTSTR pszPathName, LPTSTR pszBuffer/*MAX_PATH*/)
{
        ASSERT(AfxIsValidString(pszPathName));
        ASSERT(pszBuffer != NULL && AfxIsValidAddress(pszBuffer, MAX_PATH));

        LPTSTR pFilePart;
        *pszBuffer = '\0';
        return ::GetFullPathName(pszPathName, MAX_PATH, pszBuffer, &pFilePart);
}
