#pragma once
#include <shlwapi.h>

/////////////////////////////////////////////////////////////////////////////
#ifndef SIZEOF
#define SIZEOF(x)               (sizeof(x) / sizeof(x[0]))
#endif

#ifndef SIZEOF_NO_NULL
#define SIZEOF_NO_NULL(x)       (sizeof(x) / sizeof(x[0]) - 1)
#endif

const int NUM_CX_APP_IMAGE      = 16;
const int NUM_CY_APP_IMAGE      = 16;
const int NUM_CX_BAR_IMAGE      = 16;
const int NUM_CY_BAR_IMAGE      = 16;
const int NUM_CX_DLG_IMAGE      = 48;
const int NUM_CY_DLG_IMAGE      = 48;

const COLORREF CLR_MASK         = RGB(0xff, 0x00, 0xff);

/////////////////////////////////////////////////////////////////////////////
// ûӿ״̬ЩֵǶֵܸģ
const int UI_UNCHECK            = 0;
const int UI_CHECK              = 1;
const int UI_INDETERMINATE      = 2;

enum EImageToolBar
{
	IMAGE_TBB_NEW,
	IMAGE_TBB_OPEN,
	IMAGE_TBB_SAVE,
        IMAGE_TBB_SAVE_ALL,
        
        IMAGE_TBB_PRIVIEW,
        IMAGE_TBB_PRINT,
        
        IMAGE_TBB_UNDO,
        IMAGE_TBB_REDO,
        
        IMAGE_TBB_CLEAR,
        IMAGE_TBB_CUT,
        IMAGE_TBB_COPY,
        IMAGE_TBB_PASTE,

        IMAGE_TBB_FIND,
        IMAGE_TBB_REPLACE,

        IMAGE_TBB_TOGGLE_BOOKMARK,
        IMAGE_TBB_NEXT_BOOKMARK,
        IMAGE_TBB_PREV_BOOKMARK,
        IMAGE_TBB_CLEAR_ALL_BOOKMARKS,

        IMAGE_TBB_WINDOW_CASCADE,
        IMAGE_TBB_WINDOW_TILE_HORZ,
        IMAGE_TBB_WINDOW_TILE_VERT,

        IMAGE_TBB_VIEW_LINE_NUMBER,
        IMAGE_TBB_VIEW_RULER,
        IMAGE_TBB_VIEW_LINE_BREAK,
        IMAGE_TBB_VIEW_WHITE_SPACE,
        IMAGE_TBB_WORD_WRAP,
};

enum EImageGlobals
{
        IMAGE_BTN_PREVIEW_PRINT,
        IMAGE_BTN_PREVIEW_CLOSE,
        IMAGE_BTN_PREVIEW_ONE_PAGE,
        IMAGE_BTN_PREVIEW_TWO_PAGES,
        IMAGE_BTN_PREVIEW_NEXT,
        IMAGE_BTN_PREVIEW_PREV,
        IMAGE_BTN_PREVIEW_ZOOM_IN,
        IMAGE_BTN_PREVIEW_ZOOM_OUT,
};

/////////////////////////////////////////////////////////////////////////////
static const TCHAR CHR_FILE_FILTER_NULL_CHAR_MFC        = '|';
static const TCHAR STR_MODIFIED_DOCUMENT_TITLE_FLAG[]   = _T(" *");

/////////////////////////////////////////////////////////////////////////////
// 滻¼
// FILE: INF_DEFAULT
// SECTION: szSectionHistoryFindWhat
// SECTION: szSectionHistoryReplaceWith
static const TCHAR szSectionHistoryFindWhat[]           = _T("HistoryFind");
static const TCHAR szSectionHistoryFindWhat_szItem[]    = _T("%02d");

static const TCHAR szSectionHistoryReplaceWith[]        = _T("HistoryReplace");
static const TCHAR szSectionHistoryReplaceWith_szItem[] = _T("%02d");

// ĲʹINF_DEFAULT
static const TCHAR szSectionSearch[]                    = _T("Search");
static const TCHAR szSectionSearch_bDirectDown[]        = _T("Down");
static const TCHAR szSectionSearch_bMatchCase[]         = _T("Case");
static const TCHAR szSectionSearch_bMatchWholeWord[]    = _T("WholeWord");

// Ĭֵ
const int NUM_SEARCH_MIN_HISTORY_ITEMS                  = 0;
const int NUM_SEARCH_MAX_HISTORY_ITEMS                  = 16;

/////////////////////////////////////////////////////////////////////////////
// Printing...
static const TCHAR szSectionPrinting[]                  = _T("Printing");
static const TCHAR szSectionPrinting_szHeader[]         = _T("Header");
static const TCHAR szSectionPrinting_szFooter[]         = _T("Footer");
static const TCHAR szSectionPrinting_nMarginLeft[]      = _T("MarginLeft");
static const TCHAR szSectionPrinting_nMarginTop[]       = _T("MarginTop");
static const TCHAR szSectionPrinting_nMarginRight[]     = _T("MarginRight");
static const TCHAR szSectionPrinting_nMarginBottom[]    = _T("MarginBottom");

// λ1/100MM
const int NUM_PRINTING_DEF_FORM_WIDTH                   = 21000;
const int NUM_PRINTING_MIN_FORM_WIDTH                   = 1000;
const int NUM_PRINTING_MAX_FORM_WIDTH                   = 100000;

const int NUM_PRINTING_DEF_FORM_HEIGHT                  = 29700;
const int NUM_PRINTING_MIN_FORM_HEIGHT                  = 1000;
const int NUM_PRINTING_MAX_FORM_HEIGHT                  = 100000;

// λ1/100MM
const int NUM_PRINTING_DEF_MARGIN_LEFT                  = 1270;
const int NUM_PRINTING_MIN_MARGIN_LEFT                  = 0;
const int NUM_PRINTING_MAX_MARGIN_LEFT                  = INT_MAX;

const int NUM_PRINTING_DEF_MARGIN_TOP                   = 1270;
const int NUM_PRINTING_MIN_MARGIN_TOP                   = 0;
const int NUM_PRINTING_MAX_MARGIN_TOP                   = INT_MAX;

const int NUM_PRINTING_DEF_MARGIN_RIGHT                 = 1270;
const int NUM_PRINTING_MIN_MARGIN_RIGHT                 = 0;
const int NUM_PRINTING_MAX_MARGIN_RIGHT                 = INT_MAX;

const int NUM_PRINTING_DEF_MARGIN_BOTTOM                = 1270;
const int NUM_PRINTING_MIN_MARGIN_BOTTOM                = 0;
const int NUM_PRINTING_MAX_MARGIN_BOTTOM                = INT_MAX;

/////////////////////////////////////////////////////////////////////////////
class CApp;
class CAppFrame;
class CAppSettings;

class CAppData
{
public:
        CAppData();
        ~CAppData();
public:
        void           Initialize();

private: // 
        struct CDataApp
        {
                CApp*          pApp;
                CAppFrame*     pAppFrame;
                CAppSettings*  pAppSettings;
        };
        CDataApp       m_dataApp;

public:
        CApp*          App() const;
        CAppFrame*     AppFrame() const;
        CAppSettings*  AppSettings() const;

        void           SetApp(CApp* pApp);
        void           SetAppFrame(CAppFrame* pAppFrame);
        void           SetAppSettings(CAppSettings* pAppSettings);

private: // Դ
        struct CDataRsrc
        {
                HIMAGELIST     hImlToolbar;
                HIMAGELIST     hImlGlobals;

                CSize          sizeAppImage;
                CSize          sizeBarImage;
                CSize          sizeTBButton;
                CSize          sizeDlgImage;

                
                HFONT          hFontH1;
                HFONT          hFontH2;
                HFONT          hFontForm;
        };
        CDataRsrc      m_dataRsrc;
public:
        const CSize&   sizeAppImage() const;
        const CSize&   sizeBarImage() const;
        const CSize&   sizeDlgImage() const;
        const CSize&   sizeTBButton() const;

public:
        HIMAGELIST     ImageListToolbar() const;
        HIMAGELIST     ImageListGlobals() const;

        HFONT          FontH1() const;
        HFONT          FontH2() const;
        HFONT          FontForm() const;
};
extern CAppData appData;

/////////////////////////////////////////////////////////////////////////////
inline CApp*           CAppData::App() const               { ASSERT(this != NULL); return m_dataApp.pApp; }
inline CAppFrame*      CAppData::AppFrame() const          { ASSERT(this != NULL); return m_dataApp.pAppFrame; }
inline CAppSettings*   CAppData::AppSettings() const       { ASSERT(this != NULL); return m_dataApp.pAppSettings; }
inline void            CAppData::SetApp(CApp* pApp)        { m_dataApp.pApp = pApp; }
inline void            CAppData::SetAppFrame(CAppFrame* pAppFrame) { m_dataApp.pAppFrame = pAppFrame; }
inline void            CAppData::SetAppSettings(CAppSettings* pAppSettings) { m_dataApp.pAppSettings = pAppSettings; }

inline const CSize&    CAppData::sizeAppImage() const      { return m_dataRsrc.sizeAppImage; }
inline const CSize&    CAppData::sizeBarImage() const      { return m_dataRsrc.sizeBarImage; }
inline const CSize&    CAppData::sizeDlgImage() const      { return m_dataRsrc.sizeDlgImage; }
inline const CSize&    CAppData::sizeTBButton() const      { return m_dataRsrc.sizeTBButton; }

inline HIMAGELIST      CAppData::ImageListToolbar() const  { return m_dataRsrc.hImlToolbar; }
inline HIMAGELIST      CAppData::ImageListGlobals() const  { return m_dataRsrc.hImlGlobals; }

inline HFONT           CAppData::FontH1() const            { return m_dataRsrc.hFontH1; }
inline HFONT           CAppData::FontH2() const            { return m_dataRsrc.hFontH2; } 
inline HFONT           CAppData::FontForm() const          { return m_dataRsrc.hFontForm; } 

/////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////
namespace CGlobals
{
        /////////////////////////////////////////////////////////////////////
        // ЩȫֱѾطʼ
        // appData.pAppappData.pAppSettingszCApp::InitInstance()ʼ
        // appData.pAppFrameCAppFrame::CAppFrame()ﱻʼ
        CApp*          GetApp();
        CAppSettings*  GetAppSettings();
        CAppFrame*     GetAppFrame();

        /////////////////////////////////////////////////////////////////////
        int            appAlert1(UINT nID, UINT nType);
        int            appAlert1(LPCTSTR pszText, UINT nType);
        int _cdecl     appAlert2(UINT nID, UINT nType, ...);

        /////////////////////////////////////////////////////////////////////
        INT_PTR        appGetMsgString(UINT nID, LPTSTR pszBuf, INT_PTR cch);
        void           appGetSysErrMsg(DWORD dwMsgID, CString& strOut);
        INT_PTR        appGetToolTipString(UINT nID, LPTSTR pszBuf, INT_PTR cch);
        void           appGlobalFree(HGLOBAL hGlobal);
        BOOL           appIsEqualBool(BOOL b1, BOOL b2);
        
        /////////////////////////////////////////////////////////////////////
        // ַ
        BOOL _cdecl    strPrintf(LPTSTR pszDst, int cchDst, UINT nIdFormat, ...);
        BOOL _cdecl    strPrintf(LPTSTR pszDst, int cchDst, LPCTSTR pszFormat, ...);
        void           strCat(LPTSTR pszDst, int cchDst, LPCTSTR pszSrc);
        void           strCpy(LPTSTR pszDst, int cchDst, LPCTSTR pszSrc);
        int            strLen(LPCTSTR psz);
        LPTSTR         strInc(LPCTSTR psz);
        LPTSTR         strChr(LPCTSTR psz, int ch);
        LPTSTR         strRChr(LPCTSTR psz, int ch);
        int            strCmp(LPCTSTR psz1, LPCTSTR psz2);
        void           strCpyN(LPTSTR pszDst, int cchDst, LPCTSTR pszSrc, int cchSrc);

        /////////////////////////////////////////////////////////////////////
        // жһ·ǷΪĿ¼µġ...Ŀ¼
        BOOL           pathIsDots(LPCTSTR pszPathName);

        // жǷ·ָ\/
        BOOL           pathIsDirSep(TCHAR ch);

        // Ƿָļڣͼ·ɾͷβհַβб˵ȣ
        BOOL           pathIsFileExists(LPTSTR pszPathName);

        // Ƿָ·ڣͼ·ɾͷβհַβб˵ȣ
        BOOL           pathIsPathExists(LPTSTR pszPathName);

        LPCTSTR        pathGetFileExt(LPCTSTR pszPathName);
        UINT           pathGetFileExt(LPCTSTR pszPathName, LPTSTR pszBuffer);

        LPCTSTR        pathGetFileName(LPCTSTR pszPathName);
        UINT           pathGetFileName(LPCTSTR pszPathName, LPTSTR pszBuffer);
        
        LPCTSTR        pathGetDirName(LPCTSTR pszPathName);
        UINT           pathGetDirName(LPCTSTR pszPathName, LPTSTR pszBuffer);
        
        UINT           pathGetRoot(LPCTSTR pszPathName, LPTSTR pszBuffer);
        UINT           pathGetFullPathName(LPCTSTR pszPathName, LPTSTR pszBuffer);

        // չ
        BOOL           pathAddExtension(LPTSTR pszPathName, LPCTSTR pszExt);
        BOOL           pathRemoveFileSpec(LPTSTR pszPathName);
        BOOL           pathRenameExtension(LPTSTR pszPathName, LPCTSTR pszExt);
        void           pathRemoveExtension(LPTSTR pszPathName);
        void           pathRemoveBlanks(LPTSTR pszPathName);


        // pszPath2ӵpszPath1ĺ档
        BOOL           pathAppend(LPTSTR pszPath1, LPCTSTR pszPath2);

        BOOL           pathMatchSpec(LPCTSTR pszFileParam, LPCTSTR pszSpec);
}

/////////////////////////////////////////////////////////////////////////////
inline BOOL CGlobals::pathIsDirSep(TCHAR c)
{
        return (c == '\\' || c == '/');
}

inline BOOL CGlobals::pathAppend(LPTSTR pszPath1, LPCTSTR pszPath2)
{
        ASSERT(AfxIsValidString(pszPath1));
        ASSERT(AfxIsValidString(pszPath2));
        return ::PathAppend(pszPath1, pszPath2);
}

inline BOOL CGlobals::pathMatchSpec(LPCTSTR pszFileParam, LPCTSTR pszSpec)
{
        ASSERT(AfxIsValidString(pszFileParam));
        ASSERT(AfxIsValidString(pszSpec));
        return ::PathMatchSpec(pszFileParam, pszSpec);
}

inline LPCTSTR CGlobals::pathGetFileName(LPCTSTR pszPathName)
{
        ASSERT(AfxIsValidString(pszPathName));
        return ::PathFindFileName(pszPathName);
}

inline BOOL CGlobals::pathAddExtension(LPTSTR pszPathName, LPCTSTR pszExt)
{
        ASSERT(AfxIsValidString(pszPathName));
        ASSERT(AfxIsValidString(pszExt));
        return ::PathAddExtension(pszPathName, pszExt);
}

inline BOOL CGlobals::pathRemoveFileSpec(LPTSTR pszPathName)
{
        ASSERT(AfxIsValidString(pszPathName));
        return ::PathRemoveFileSpec(pszPathName);
}

inline BOOL CGlobals::pathRenameExtension(LPTSTR pszPathName, LPCTSTR pszExt)
{
        ASSERT(AfxIsValidString(pszPathName));
        ASSERT(AfxIsValidString(pszExt));
        return ::PathRenameExtension(pszPathName, pszExt);
}

inline void CGlobals::pathRemoveExtension(LPTSTR pszPathName)
{
        ASSERT(AfxIsValidString(pszPathName));
        ::PathRemoveExtension(pszPathName);
}

inline void CGlobals::pathRemoveBlanks(LPTSTR pszPathName)
{
        ASSERT(AfxIsValidString(pszPathName));
        ::PathRemoveBlanks(pszPathName);
}

/////////////////////////////////////////////////////////////////////////////
inline CApp*           CGlobals::GetApp()          { return appData.App(); }
inline CAppFrame*      CGlobals::GetAppFrame()     { return appData.AppFrame(); }
inline CAppSettings*   CGlobals::GetAppSettings()  { return appData.AppSettings(); }

/////////////////////////////////////////////////////////////////////////////
using namespace CGlobals;
