// BarTool.cpp : ʵļ
//

#include "stdafx.h"
#include "App.h"
#include "AppGlobals.h"
#include "AppFrame.h"
#include "BarTool.h"

/////////////////////////////////////////////////////////////////////////////
// CBarTool
IMPLEMENT_DYNAMIC(CBarTool, CToolBar)
BEGIN_MESSAGE_MAP(CBarTool, CToolBar)
END_MESSAGE_MAP()
CBarTool::CBarTool()
{
}

CBarTool::~CBarTool()
{
}

/////////////////////////////////////////////////////////////////////////////
// CBarTool Ϣ

/////////////////////////////////////////////////////////////////////////////
// CBarTool idle update through CBarToolCmdUI class
class CBarToolCmdUI : public CCmdUI      // class private to this file!
{
public: // re-implementations only
        virtual void   Enable(BOOL bOn);
        virtual void   SetCheck(int nCheck);
        virtual void   SetText(LPCTSTR pszText);
};

void CBarToolCmdUI::Enable(BOOL bOn)
{
        m_bEnableChanged = true;
        CBarTool* pBar = static_cast<CBarTool*>(m_pOther);
        ASSERT(pBar != NULL);
        ASSERT_KINDOF(CBarTool, pBar);
        ASSERT(m_nIndex < m_nIndexMax);

        UINT nNewStyle = pBar->GetButtonStyle(m_nIndex) & ~TBBS_DISABLED;
        if (!bOn)
        {
                nNewStyle |= TBBS_DISABLED;

                // WINBUG: If a button is currently pressed and then is disabled
                // COMCTL32.DLL does not unpress the button, even after the mouse
                // button goes up!  We work around this bug by forcing TBBS_PRESSED
                // off when a button is disabled.
                nNewStyle &= ~TBBS_PRESSED;

                // ťdisabled״̬ôchecked״̬
                nNewStyle &= ~TBBS_CHECKED;
        }
        ASSERT(!(nNewStyle & TBBS_SEPARATOR));
        pBar->SetButtonStyle(m_nIndex, nNewStyle);
}

void CBarToolCmdUI::SetCheck(int nCheck)
{
        ASSERT(nCheck >= 0 && nCheck <= 2); // 0=>off, 1=>on, 2=>indeterminate
        CBarTool* pBar = static_cast<CBarTool*>(m_pOther);
        ASSERT(pBar != NULL);
        ASSERT_KINDOF(CBarTool, pBar);
        ASSERT(m_nIndex < m_nIndexMax);

        UINT nNewStyle = pBar->GetButtonStyle(m_nIndex) & ~(TBBS_CHECKED | TBBS_INDETERMINATE);
        if (nCheck == UI_CHECK)
        {
                nNewStyle |= TBBS_CHECKED;
        }
        else if (nCheck == UI_INDETERMINATE)
        {
                nNewStyle |= TBBS_INDETERMINATE;
        }
        ASSERT(!(nNewStyle & TBBS_SEPARATOR));
        pBar->SetButtonStyle(m_nIndex, nNewStyle | TBBS_CHECKBOX);
}

void CBarToolCmdUI::SetText(LPCTSTR)
{
        // ignore it
}

void CBarTool::OnUpdateCmdUI(CFrameWnd* pTarget, BOOL bDisableIfNoHndler)
{
        CBarToolCmdUI state;
        state.m_pOther    = this;
        state.m_nIndexMax = static_cast<UINT>(DefWindowProc(TB_BUTTONCOUNT, 0, 0));
        
        for (state.m_nIndex = 0;
                state.m_nIndex < state.m_nIndexMax;
                state.m_nIndex++)
        {
                // get buttons state
                TBBUTTON button;
                VERIFY(DefWindowProc(TB_GETBUTTON,
                        state.m_nIndex,
                        reinterpret_cast<LPARAM>(&button)));
                state.m_nID = button.idCommand;

                // ignore separators
                if (!(button.fsStyle & TBSTYLE_SEP))
                {
                        // allow reflections
                        if (CWnd::OnCmdMsg(0, 
                                MAKELONG(CN_UPDATE_COMMAND_UI & 0xff, WM_COMMAND + WM_REFLECT_BASE), 
                                &state,
                                NULL))
                        {
                                continue;
                        }

                        // allow the toolbar itself to have update handlers
                        if (CWnd::OnCmdMsg(state.m_nID, CN_UPDATE_COMMAND_UI, &state, NULL))
                        {
                                continue;
                        }

                        // allow the owner to process the update
                        state.DoUpdate(pTarget, bDisableIfNoHndler);
                }
        }

        // update the dialog controls added to the toolbar
        UpdateDialogControls(pTarget, bDisableIfNoHndler);
}
