// DlgPrint.cpp : ʵļ
//

#include "stdafx.h"
#include <winspool.h>
#include <dlgs.h>
#include "App.h"
#include "AppGlobals.h"
#include "AppSettings.h"
#include "AppFrame.h"
#include "DlgBase.h"
#include "DlgPrint.h"

/////////////////////////////////////////////////////////////////////////////
// RCԴļеĴӡԻʹ<dlgs.h>жĿؼʶVCԴ
// Щؼʶ˳
#define IDC_PRINT_BTN_SET_PRINTER               psh3
#define NUM_PRINTING_MIN_PRINT_PAGES_RANGE      1
#define NUM_PRINTING_MAX_PRINT_PAGES_RANGE      USHRT_MAX

/////////////////////////////////////////////////////////////////////////////
// CDlgPrint
IMPLEMENT_DYNAMIC(CDlgPrint, CPageSetupDialog)
BEGIN_MESSAGE_MAP(CDlgPrint, CPageSetupDialog)
        ON_BN_CLICKED(IDC_PRINT_BTN_SET_HEADER_TEXT, OnSetHeaderFooterText)
        ON_BN_CLICKED(IDC_PRINT_BTN_SET_FOOTER_TEXT, OnSetHeaderFooterText)
END_MESSAGE_MAP()

CDlgPrint::CDlgPrint(CMyEditView* pOwner) : CPageSetupDialog(0, pOwner)
{
        PRINTDLG pd;
        memset(&pd, 0, sizeof(pd));
        GetApp()->GetPrinterDeviceDefaults(&pd);

        m_pi = GetAppSettings()->PrintingGetInfo();
        m_pOwner        = pOwner;
        m_bPageSetup    = (pOwner == NULL);
        m_psd.rtMargin  = m_pi.m_rectMargin;
        m_psd.hDevMode  = pd.hDevMode;
        m_psd.hDevNames = pd.hDevNames;
        m_psd.Flags    &= ~(PSD_SHOWHELP | PSD_INTHOUSANDTHSOFINCHES);
        m_psd.Flags    |= PSD_ENABLEPAGESETUPTEMPLATE | PSD_INHUNDREDTHSOFMILLIMETERS |
                PSD_MARGINS | PSD_DEFAULTMINMARGINS;
        m_psd.hInstance = AfxGetResourceHandle();
        m_psd.lpPageSetupTemplateName = MAKEINTRESOURCE(IDD_PRINT_INITIAL);
}

CDlgPrint::~CDlgPrint()
{
}


/////////////////////////////////////////////////////////////////////////////
// CDlgPrint Ϣ
BOOL CDlgPrint::OnInitDialog()
{
        CPageSetupDialog::OnInitDialog();

        // TODO:  ڴӶĳʼ
        CDlgBase::DlgEnableItem(this, IDC_PRINT_EDT_SCALE, false);
        CDlgBase::DlgEnableItem(this, IDC_PRINT_SPN_SCALE, false);

        UpdateDataSet();
        return true;  // return true unless you set the focus to a control
        // 쳣: OCX ҳӦ false
}

void CDlgPrint::OnOK()
{
        // TODO: ڴרô/û
        if (!UpdateDataGet())
        {
                return;
        }

        CPageSetupDialog::OnOK();

        // ҳ߾ֽųߴ硣
        m_pi.m_sizePaper.cx = m_psd.ptPaperSize.x;
        m_pi.m_sizePaper.cy = m_psd.ptPaperSize.y;
        m_pi.m_rectMargin.CopyRect(&m_psd.rtMargin);

        // Сҳ߾ࡣ
        CDC dcPrint;
        if (dcPrint.Attach(CreatePrinterDC()))
        {
                CSize sizeLUsPI; // Logic Unit Per Inch
                sizeLUsPI.cx = dcPrint.GetDeviceCaps(LOGPIXELSX);
                sizeLUsPI.cy = dcPrint.GetDeviceCaps(LOGPIXELSY);
                
                CSize sizePaper; // ֽųߴ硣
                sizePaper.cx = dcPrint.GetDeviceCaps(PHYSICALWIDTH);
                sizePaper.cy = dcPrint.GetDeviceCaps(PHYSICALHEIGHT);
                dcPrint.DPtoLP(&sizePaper);

                CSize sizePrint; // ɴӡΧ
                sizePrint.cx = dcPrint.GetDeviceCaps(HORZRES);
                sizePrint.cy = dcPrint.GetDeviceCaps(VERTRES);
                dcPrint.DPtoLP(&sizePrint);

                CSize sizeOfsLT; // ߺϱߣ߼λ
                sizeOfsLT.cx = dcPrint.GetDeviceCaps(PHYSICALOFFSETX);
                sizeOfsLT.cy = dcPrint.GetDeviceCaps(PHYSICALOFFSETY);
                dcPrint.DPtoLP(&sizeOfsLT);

                CSize sizeOfsRB; // ұߺ±ߣ߼λ
                sizeOfsRB.cx = sizePaper.cx - sizeOfsLT.cx - sizePrint.cx;
                sizeOfsRB.cy = sizePaper.cy - sizeOfsLT.cy - sizePrint.cy;

                CSize sizeLT_MM; // ת1/100MMλ
                sizeLT_MM.cx = (LONG)((FLOAT)sizeOfsLT.cx * 2540 / sizeLUsPI.cx);
                sizeLT_MM.cy = (LONG)((FLOAT)sizeOfsLT.cy * 2540 / sizeLUsPI.cy);
                
                CSize sizeRB_MM; // ת1/100MMλ
                sizeRB_MM.cx = (LONG)((FLOAT)sizeOfsRB.cx * 2540 / sizeLUsPI.cx);
                sizeRB_MM.cy = (LONG)((FLOAT)sizeOfsRB.cy * 2540 / sizeLUsPI.cy);

                CRect& rect = m_pi.m_rectMargin;
                rect.left   = max(sizeLT_MM.cx, rect.left);
                rect.top    = max(sizeLT_MM.cy, rect.top);
                rect.right  = max(sizeRB_MM.cx, rect.right);
                rect.bottom = max(sizeRB_MM.cy, rect.bottom);

                dcPrint.DeleteDC();
        }
        
        // ӡá
        GetAppSettings()->PrintingSetInfo(m_pi);

        // ҪӡھִС
        if ((m_pOwner != NULL) && (::IsWindow(m_pOwner->GetSafeHwnd())))
        {
                m_pOwner->SendMessage(WM_COMMAND,
                        MAKEWPARAM(ID_FILE_PRINT, 0),
                        0);
        }
}

void CDlgPrint::OnCancel()
{
        // TODO: ڴרô/û

        CPageSetupDialog::OnCancel();
}

/////////////////////////////////////////////////////////////////////////////
void CDlgPrint::OnSetHeaderFooterText()
{
        // TODO: ڴӿؼ֪ͨ
        struct CMacroMap
        {
                UINT           nID;
                LPCTSTR        pszMacro;
        };

        static const CMacroMap l_macro_map[] =
        {
                {ID_PRINT_MACRO_DATE,         PFX_EC_PRINT_MACRO_DATE},
                {ID_PRINT_MACRO_TIME,         PFX_EC_PRINT_MACRO_TIME},
                {ID_PRINT_MACRO_CURRENT_PAGE, PFX_EC_PRINT_MACRO_CURRENT_PAGE},
                {ID_PRINT_MACRO_TOTAL_PAGES,  PFX_EC_PRINT_MACRO_TOTAL_PAGES},
                {ID_PRINT_MACRO_FILE_NAME,    PFX_EC_PRINT_MACRO_FILE_NAME},
                {ID_PRINT_MACRO_PATH_NAME,    PFX_EC_PRINT_MACRO_PATH_NAME},
                {ID_PRINT_MACRO_TAB,          PFX_EC_PRINT_MACRO_TAB},
                {ID_PRINT_MACRO_CRLF,         PFX_EC_PRINT_MACRO_CRLF},
                {ID_PRINT_MACRO_ALIGN_LEFT,   PFX_EC_PRINT_MACRO_ALIGN_LEFT},
                {ID_PRINT_MACRO_ALIGN_CENTER, PFX_EC_PRINT_MACRO_ALIGN_CENTER},
                {ID_PRINT_MACRO_ALIGN_RIGHT,  PFX_EC_PRINT_MACRO_ALIGN_RIGHT},
        };

        int nIDEdt;
        int nIDBtn;
        switch (GetAppFrame()->GetCurrentCommand())
        {
        default:
                return;
        case IDC_PRINT_BTN_SET_HEADER_TEXT:
                nIDBtn = IDC_PRINT_BTN_SET_HEADER_TEXT;
                nIDEdt = IDC_PRINT_EDT_HEADER;
                break;
        
        case IDC_PRINT_BTN_SET_FOOTER_TEXT:
                nIDBtn = IDC_PRINT_BTN_SET_FOOTER_TEXT;
                nIDEdt = IDC_PRINT_EDT_FOOTER; 
                break;
        }

        // ȡ˵ꡣ
        CRect rect;
        GetDlgItem(nIDBtn)->GetWindowRect(&rect);

        CMenu Menu;
        VERIFY(Menu.LoadMenu(IDR_POPUP_PRINT_MACRO));
        
        CPoint point(rect.left, rect.bottom);
        UINT nIDCmd = GetAppFrame()->CreateShortcutMenu(this,
                Menu.GetSubMenu(0),
                point);
        
        if (nIDCmd != 0) // nIDCmdʾ˵ȡ
        {
                LPCTSTR pszMacro = NULL;
                for (int i = 0; i < SIZEOF(l_macro_map); i++)
                {
                        if (nIDCmd == l_macro_map[i].nID)
                        {
                                pszMacro = l_macro_map[i].pszMacro;
                                break;
                        }
                }
                
                if (pszMacro != NULL)
                {
                        CWnd* pWndEdt = GetDlgItem(nIDEdt);
                        ASSERT(pWndEdt != NULL);

                        CEdit Edit;
                        Edit.Attach(pWndEdt->GetSafeHwnd());
                       
                        // ӡ
                        Edit.ReplaceSel(pszMacro, true);
                        
                        // 뽹㡣
                        Edit.SetFocus();
                        Edit.Detach();
                }
        }
}

/////////////////////////////////////////////////////////////////////////////
void CDlgPrint::UpdateDataSet()
{
        // ע
        SetDlgItemText(IDC_PRINT_EDT_HEADER, m_pi.m_strHeader);
        SetDlgItemText(IDC_PRINT_EDT_FOOTER, m_pi.m_strFooter);

        // ҳ뷶Χʼҳ㣬ҳձʾȫӡ
        if (!m_bPageSetup)
        {
                SetDlgItemInt(IDC_PRINT_EDT_PAGE_FROM, 1, false);
                SetDlgItemText(IDC_PRINT_EDT_PAGE_TO, _T(""));
        }
        else
        {
                CDlgBase::DlgEnableItem(this, IDC_PRINT_EDT_PAGE_FROM, false);
                CDlgBase::DlgEnableItem(this, IDC_PRINT_EDT_PAGE_TO, false);
        }
}

BOOL CDlgPrint::UpdateDataGet()
{
        CMyEditPrintInfo pi;

        // ҳ뷶Χӵڼҳڼҳ
        pi.m_nPageFrom = NUM_PRINTING_MIN_PRINT_PAGES_RANGE;
        pi.m_nPageTo   = NUM_PRINTING_MAX_PRINT_PAGES_RANGE;

        if (!m_bPageSetup) // ҳòҪȡӡΧ
        {
                if (!CDlgBase::DlgGetItemUINT(this,
                        IDC_PRINT_EDT_PAGE_FROM,
                        IDS_E_PRINT_INVALID_PAGES_RANGE,
                        pi.m_nPageFrom,
                        NUM_PRINTING_MIN_PRINT_PAGES_RANGE,
                        NUM_PRINTING_MAX_PRINT_PAGES_RANGE))
                {
                        return false;
                }

                // ӡҳջ˿հַͱû
                // Ӵӡʼҳӡĵһҳ
                CString strToPageText;
                GetDlgItemText(IDC_PRINT_EDT_PAGE_TO, strToPageText);
                strToPageText.TrimLeft();
                strToPageText.TrimRight();

                if (!strToPageText.IsEmpty()
                        && !CDlgBase::DlgGetItemUINT(this,
                        IDC_PRINT_EDT_PAGE_TO,
                        IDS_E_PRINT_INVALID_PAGES_RANGE,
                        pi.m_nPageTo,
                        NUM_PRINTING_MIN_PRINT_PAGES_RANGE,
                        NUM_PRINTING_MAX_PRINT_PAGES_RANGE))
                {
                        return false;
                }

                if (pi.m_nPageFrom > pi.m_nPageTo)
                {
                        appAlert2(IDS_E_PRINT_INVALID_PAGES_SEQUENCE_NUMBER,
                                MB_OK | MB_ICONEXCLAMATION,
                                pi.m_nPageFrom,
                                pi.m_nPageTo);
                        return false;
                }
        }

        // ͽע
        GetDlgItemText(IDC_PRINT_EDT_HEADER, pi.m_strHeader);
        GetDlgItemText(IDC_PRINT_EDT_FOOTER, pi.m_strFooter);

        m_pi = pi; // ȷݡ
        return true;
}
