// MyEditDoc.cpp : ʵļ
//

#include "stdafx.h"
#include "App.h"
#include "AppFrame.h"
#include "AppGlobals.h"
#include "AppSettings.h"
#include "MyEditDoc.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

/////////////////////////////////////////////////////////////////////////////
// CMyEditDoc
IMPLEMENT_DYNCREATE(CMyEditDoc, CPfxEditDoc)
BEGIN_MESSAGE_MAP(CMyEditDoc, CPfxEditDoc)
END_MESSAGE_MAP()

CMyEditDoc::CMyEditDoc()
{
        m_nOpenConverter = GetAppFrame()->m_dataTextEdit.nFileConverter;
        m_nSaveConverter = PFX_EC_FILE_CONVERTER_ANSI;
}

CMyEditDoc::~CMyEditDoc()
{
}

/////////////////////////////////////////////////////////////////////////////
// CMyEditDoc 
BOOL CMyEditDoc::OnInitDocument(LPCTSTR pszPathName)
{
        // һҪûʵ֡
        CPfxEditDoc::OnInitDocument(pszPathName);

        const CMyEditTypeInfo* pTypeInfo = GetAppSettings()->FileTypeInfoFromFileName(pszPathName);
        if (pTypeInfo != NULL)
        {
                SetFileTypeInfo(const_cast<CMyEditTypeInfo*>(pTypeInfo));
        }

        // ĵǷֻ״̬Ĭϵǲû޸ֻļ
        if (pszPathName != NULL) 
        {
                CFileStatus status;
                CFile::GetStatus(pszPathName, status);
                SetReadOnly((status.m_attribute & CFile::readOnly) == CFile::readOnly);
        }
        return true;
}

LONG CMyEditDoc::OnEvent(UINT nCode, LPARAM lParam)
{
        CAppFrame* pAppFrame = GetAppFrame();
        ASSERT(pAppFrame != NULL);
        
        switch (nCode)
        {
        case PFX_EN_WORD_WRAPPING:
                break;
        
        case PFX_EN_SEARCH_PASSED_EOF:
                break;
        
        case PFX_EN_READ_ONLY_DOCUMENT:
                break;
        
        case PFX_EE_OUT_OF_MEMORY:
        case PFX_EE_OUT_OF_RESOURCE:
        case PFX_EE_UNKNOWN_ERROR:
        case PFX_EE_INTERNAL_ERROR:
        case PFX_EE_CONVERT_ERR_ON_LOADING:
        case PFX_EE_CONVERT_ERR_ON_SAVING:
                {
                        struct CErrMsg
                        {
                                UINT nIDCode;
                                UINT nIDString;
                        };
                        
                        static const CErrMsg s_arrErrMsg[] =
                        {
                                {PFX_EE_OUT_OF_MEMORY,   IDS_E_NOT_ENOUGH_MEMORY},
                                {PFX_EE_OUT_OF_RESOURCE, IDS_E_NOT_ENOUGH_RESOURCE},
                                //{PFX_EE_UNKNOWN_ERROR,   ??},
                                //{PFX_EE_INTERNAL_ERROR,  ??},
                                {PFX_EE_CONVERT_ERR_ON_LOADING, IDS_E_CONVERT_ERR_ON_LOADING},
                                {PFX_EE_CONVERT_ERR_ON_SAVING, IDS_E_CONVERT_ERR_ON_SAVING},
                        };

                        for (int i = 0; i < SIZEOF(s_arrErrMsg); i++)
                        {
                                if (s_arrErrMsg[i].nIDCode == nCode)
                                {
                                        nCode = s_arrErrMsg[i].nIDString;
                                        break;
                                }
                        }
                        
                        appAlert1(nCode, MB_OK | MB_ICONERROR);
                }
                break;

        default:
                break;
        }
        return 0;
}

BOOL CMyEditDoc::SaveModified()
{
        if (!IsModified())
        {
                return true;
        }
        
        // ĵ·ͻȡ·ĵ½ľı
        // 
        CString strPathName = GetPathName();
        if (strPathName.IsEmpty())
        {
                strPathName = GetTitle();
                strPathName.TrimRight(STR_MODIFIED_DOCUMENT_TITLE_FLAG);
        }
        
        CString strPrompt;
        strPrompt.Format(IDS_P_QUERY_TO_SAVE_DOCUMENT, (LPCTSTR)strPathName);
        
        BOOL bRetVal;
        switch (AfxMessageBox(strPrompt, MB_YESNOCANCEL))
        {
        case IDCANCEL:
                bRetVal = false;
                break;
        
        case IDYES:
                bRetVal = DoFileSave();
                break;
        
        case IDNO: 
        default: // ͨ
                bRetVal = true;
                break;
        }
        
        return bRetVal;
}

BOOL CMyEditDoc::DoSave(LPCTSTR pszPathName, BOOL bReplace)
// Save the document data to a file
// pszPathName = path name where to save document file
// if pszPathName is NULL then the user will be prompted (SaveAs)
// note: pszPathName can be different than 'm_strPathName'
// if 'bReplace' is true will change file name if successful (SaveAs)
// if 'bReplace' is false will not change path name (SaveCopyAs)
{
        CAppSettings* pAppSettings = GetAppSettings();
        ASSERT(pAppSettings != NULL);

        // ʾȡǰַ뷽ͻз
        // ַ뷽ָANSIUNICODEUTF8ȡ
        // зָDOSUNIXMACȡ
        LONG nOldFileConverter = GetFileConverter();
        LONG nOldLineBreakType = GetLineBreakType();
        LONG nNewFileConverter = GetFileConverter();
        LONG nNewLineBreakType = GetLineBreakType();

        CString newName = pszPathName;
        if (newName.IsEmpty() || IsReadOnly())
        {
                if (IsReadOnly())
                {
                        bReplace = true;
                }

                // ʾʾΪԻʱûѡַ뷽ͻ
                // з
                if (!GetSaveAsFileName(newName,
                        bReplace,
                        nNewFileConverter,
                        nNewLineBreakType))
                {
                        return false;
                }
        }

        // ʾûµı뷽ͻз
        SetFileConverter(nNewFileConverter);
        SetLineBreakType(nNewLineBreakType);
        BOOL bResult = false;
        
        try
        {
                bResult = OnSaveDocument(newName);
        }
        catch (CException* e)
        {
                TRACE("Failed to save file: %s\n", newName);
                e->Delete();
        }

        if (!bResult) // ʧܣҪָԭתͻиʽ
        {
                SetFileConverter(nOldFileConverter);
                SetLineBreakType(nOldLineBreakType);
        }

        // ʧܣǡΪҪղ½ļɾ
        if (!bResult && (pszPathName == NULL))
        {
                // be sure to delete the file
                try
                {
                        CFile::Remove(newName);
                }
                catch (CException* e)
                {
                        TRACE("Warning: failed to delete file after failed SaveAs.\n");
                        e->Delete();
                }
        }

        // reset the title and change the document name
        if (bResult && bReplace)
        {
                SetPathName(newName);
        }
        
        return bResult;
}
/////////////////////////////////////////////////////////////////////////////
// û޸ĵҪڳıһ*ʾĵѾ
// ޸ġ
void CMyEditDoc::SetModifiedFlag(BOOL bModified)
{
        BOOL bDocModified = IsModified();
        if ((bModified && bDocModified) || (!bModified && !bDocModified))
        {
                return;
        }
        
        CPfxEditDoc::SetModifiedFlag(bModified);
        
        CString strTitle = GetTitle();
        if (bModified)
        {
                // ĵ޸ı־һǡ*
                if (strTitle.Right(SIZEOF_NO_NULL(STR_MODIFIED_DOCUMENT_TITLE_FLAG))
                        != STR_MODIFIED_DOCUMENT_TITLE_FLAG)
                {
                        strTitle += STR_MODIFIED_DOCUMENT_TITLE_FLAG;
                }
        }
        else
        {
                if (strTitle.Right(SIZEOF_NO_NULL(STR_MODIFIED_DOCUMENT_TITLE_FLAG))
                        == STR_MODIFIED_DOCUMENT_TITLE_FLAG)
                {
                        strTitle.TrimRight(STR_MODIFIED_DOCUMENT_TITLE_FLAG);
                }
        }
        
        SetTitle(strTitle);
}

BOOL CMyEditDoc::GetSaveAsFileName(CString& strFileName,
                                   BOOL bReplace,
                                   LONG& nFileConverter,
                                   LONG& nLineBreakType)
{
        // ʾûдnFileConverternLineBreakType
        // ӦԼдΪļԻչܡ

        CDocTemplate* pTemplate = GetDocTemplate();
        ASSERT(pTemplate != NULL);
        
        strFileName = m_strPathName;
        if (bReplace && strFileName.IsEmpty())
        {
                strFileName = m_strTitle;
                
                // δֱ޸˵ĵڱһ*
                strFileName.TrimRight(STR_MODIFIED_DOCUMENT_TITLE_FLAG);
                
                // ɾĿհַ
                strFileName.TrimRight();
                
                // ɾܰķǷַ
                int iBad = strFileName.FindOneOf(_T("\\/:*?\"<>|"));
                if (iBad != -1)
                {
                        strFileName.ReleaseBuffer(iBad);
                }
                
                // ȱʡļչѾĵַָ
                CString strExt;
                if (pTemplate->GetDocString(strExt, CDocTemplate::filterExt)
                        && !strExt.IsEmpty())
                {
                        ASSERT(strExt[0] == '.');
                        strFileName += strExt;
                }
        }
        
        TCHAR szTitle[MAX_PATH];
        CAppSettings* pAppSettings = GetAppSettings();

        CFileDialog fd(false, // Save
                NULL, //pszDefExt,
                strFileName, // pszFileName
                OFN_EXPLORER | OFN_ENABLESIZING | OFN_HIDEREADONLY |
                OFN_PATHMUSTEXIST | OFN_OVERWRITEPROMPT, //dwFlags
                pAppSettings->FileFilterGetList(), // pszFilter
                GetAppFrame());  // pParentWnd
        fd.m_ofn.lpstrTitle = szTitle;

        AfxLoadString((bReplace ? AFX_IDS_SAVEFILE : AFX_IDS_SAVEFILECOPY),
                szTitle,
                SIZEOF(szTitle));

        strFileName.Empty();
        if (fd.DoModal() == IDOK)
        {
                POSITION pos = fd.GetStartPosition();
                if (pos != NULL)
                {
                        strFileName = fd.GetNextPathName(pos);
                }
        }

        if (!strFileName.IsEmpty())
        {
                CFileStatus status;
                if (CFile::GetStatus(strFileName, status)
                        && ((status.m_attribute & CFile::readOnly) == CFile::readOnly))
                {
                        appAlert2(IDS_E_CAN_NOT_OVERWRITE_READ_ONLY_FILE,
                                MB_OK | MB_ICONERROR,
                                strFileName);
                        strFileName.Empty();
                }
        }
        return !strFileName.IsEmpty();
}

BOOL CMyEditDoc::IsCurFileTypeInfo(const CMyEditTypeInfo* pTypeInfo) const
{
        return ((pTypeInfo != NULL)
                && ((const CPfxEditTypeInfo*)pTypeInfo == GetTypeInfoPtr()));
}

const CMyEditTypeInfo* CMyEditDoc::GetFileTypeInfo() const
{
        const CMyEditTypeInfo* pTypeInfo = NULL;
        CAppSettings* pAppSettings = GetAppSettings();

        POSITION pos = pAppSettings->FileTypeInfoGetFirst();
        while (pos != NULL)
        {
                const CMyEditTypeInfo* pti = pAppSettings->FileTypeInfoGetNext(pos);
                if (IsCurFileTypeInfo(pti))
                {
                        pTypeInfo = pti;
                }
        }
        return pTypeInfo;
}

void CMyEditDoc::SetFileTypeInfo(CMyEditTypeInfo* pTypeInfo)
{
        if (pTypeInfo == NULL)
        {
                return;
        }

        SetTypeInfoPtr(pTypeInfo);
}
