#pragma once
#include "pfx\inc\pfxeditctrl.h"
#include "AppGlobals.h"

/////////////////////////////////////////////////////////////////////////////
// ӡϢ
class CMyEditPrintInfo
{
public:
        // ҳ߾࣬λ1/100MM
        CRect          m_rectMargin;
        CSize          m_sizePaper;

        CString        m_strHeader;
        CString        m_strFooter;
        
        UINT           m_nPageFrom;
        UINT           m_nPageTo;

        CMyEditPrintInfo()
        {
                m_nPageFrom    = 1;
                m_nPageTo      = -1;
                m_sizePaper.cx = 0;
                m_sizePaper.cy = 0;
                m_rectMargin.SetRectEmpty();
        }
        CMyEditPrintInfo(const CMyEditPrintInfo& src)
        {
                *this = src;
        }
        CMyEditPrintInfo& operator=(const CMyEditPrintInfo& src)
        {
                m_nPageFrom = src.m_nPageFrom;
                m_nPageTo   = src.m_nPageTo;
                m_strHeader = src.m_strHeader;
                m_strFooter = src.m_strFooter;
                m_sizePaper = src.m_sizePaper;
                m_rectMargin.CopyRect(src.m_rectMargin);
                return *this;
        }
};

/////////////////////////////////////////////////////////////////////////////
class CMyEditTypeInfo : public CPfxEditTypeInfo
{
        // ļϢǷѾ롣ڳʹö̬װصķȡ
        // Ϣʱֻɨļռֵ֧ļ͵
        // չϢûȫȡݣĳļʱѶ
        // ȡϢɨ裬ֵ֧ļͲҸļ
        // ûж룬ٴɨļȡļȫϢ
        // ָ֧;ʹȱʡ÷
public:
        CMyEditTypeInfo();
public:
        BOOL           IsLoaded() const;
        BOOL           IsModified() const;
        BOOL           IsDefaultTypeInfo() const;

        CMyEditTypeInfo& operator=(const CMyEditTypeInfo& src);
public:
        BOOL           m_bLoaded;      // ǷѾװء
        BOOL           m_bModified;    // öԻ޸͵á
        UINT           m_nMenuItemID;  // ˵ʶ

        CString        m_strTypeExtensions;  // չб
        CString        m_strTypeDescription; // 
        CString        m_strTypeProfileName; // ļ
};

inline BOOL            CMyEditTypeInfo::IsLoaded() const   { return m_bLoaded; }
inline BOOL            CMyEditTypeInfo::IsModified() const { return m_bModified; }

/////////////////////////////////////////////////////////////////////////////
class CMyEditTypeInfoList : public CObject
{
        DECLARE_DYNAMIC(CMyEditTypeInfoList)
                
protected:
        struct CNode
        {
                CNode*         pNext;
                CNode*         pPrev;
                CMyEditTypeInfo data;
        };

public:
        // Construction
        CMyEditTypeInfoList(int nBlockSize = 10);
        ~CMyEditTypeInfoList();
        
        // Attributes (head and tail)
        // count of elements
        BOOL           IsEmpty() const;
        int            GetCount() const;
        
        // peek at head or tail
        CMyEditTypeInfo* GetHead();
        CMyEditTypeInfo  GetHead() const;
        CMyEditTypeInfo* GetTail();
        CMyEditTypeInfo  GetTail() const;
        
        POSITION       AddHead(const CMyEditTypeInfo* newElement);
        POSITION       AddTail(const CMyEditTypeInfo* newElement);
        void           RemoveAll();
        
        POSITION       GetHeadPosition() const;
        POSITION       GetTailPosition() const;
        CMyEditTypeInfo* GetNext(POSITION& rPosition); // return *Position++
        CMyEditTypeInfo  GetNext(POSITION& rPosition) const; // return *Position++
        CMyEditTypeInfo* GetPrev(POSITION& rPosition); // return *Position--
        CMyEditTypeInfo  GetPrev(POSITION& rPosition) const; // return *Position--
        
        CMyEditTypeInfo* GetAt(POSITION position);
        CMyEditTypeInfo  GetAt(POSITION position) const;
        void           SetAt(POSITION pos, const CMyEditTypeInfo* newElement);
        
        void           RemoveAt(POSITION position);
        
        POSITION       Find(CMyEditTypeInfo* searchValue, POSITION startAfter = NULL) const;
        POSITION       FindIndex(int nIndex) const;
        
        // Implementation
protected:
        CNode*         m_pNodeHead;
        CNode*         m_pNodeTail;
        CNode*         m_pNodeFree;
        struct CPlex*  m_pBlocks;
        int            m_nCount;
        int            m_nBlockSize;
        
        CNode*         NewNode(CNode* pPrev, CNode* pNext);
        void           FreeNode(CNode* pNode);
        
#ifdef _DEBUG
        void           Dump(CDumpContext&) const;
        void           AssertValid() const;
#endif
};

///////////////////////////////////////////////////////////////////////////////////
inline int CMyEditTypeInfoList::GetCount() const
{
        return m_nCount;
}

inline BOOL CMyEditTypeInfoList::IsEmpty() const
{
        return (m_nCount == 0);
}

inline CMyEditTypeInfo* CMyEditTypeInfoList::GetHead()
{
        ASSERT(m_pNodeHead != NULL);
        return &m_pNodeHead->data;
}

inline CMyEditTypeInfo CMyEditTypeInfoList::GetHead() const
{
        ASSERT(m_pNodeHead != NULL);
        return m_pNodeHead->data;
}

inline CMyEditTypeInfo* CMyEditTypeInfoList::GetTail()
{
        ASSERT(m_pNodeTail != NULL);
        return &m_pNodeTail->data;
}

inline CMyEditTypeInfo CMyEditTypeInfoList::GetTail() const
{
        ASSERT(m_pNodeTail != NULL);
        return m_pNodeTail->data;
}

inline POSITION CMyEditTypeInfoList::GetHeadPosition() const
{
        return (POSITION) m_pNodeHead;
}

inline POSITION CMyEditTypeInfoList::GetTailPosition() const
{
        return (POSITION) m_pNodeTail;
}

inline CMyEditTypeInfo* CMyEditTypeInfoList::GetNext(POSITION& rPosition)
// return *Position++
{
        CNode* pNode = (CNode*) rPosition;
        ASSERT(AfxIsValidAddress(pNode, sizeof(CNode)));
        rPosition = (POSITION) pNode->pNext;
        return &pNode->data;
}

inline CMyEditTypeInfo CMyEditTypeInfoList::GetNext(POSITION& rPosition) const
// return *Position++
{
        CNode* pNode = (CNode*) rPosition;
        ASSERT(AfxIsValidAddress(pNode, sizeof(CNode)));
        rPosition = (POSITION) pNode->pNext;
        return pNode->data;
}

inline CMyEditTypeInfo* CMyEditTypeInfoList::GetPrev(POSITION& rPosition)
// return *Position--
{
        CNode* pNode = (CNode*) rPosition;
        ASSERT(AfxIsValidAddress(pNode, sizeof(CNode)));
        rPosition = (POSITION) pNode->pPrev;
        return &pNode->data;
}

inline CMyEditTypeInfo CMyEditTypeInfoList::GetPrev(POSITION& rPosition) const 
// return *Position--
{
        CNode* pNode = (CNode*) rPosition;
        ASSERT(AfxIsValidAddress(pNode, sizeof(CNode)));
        rPosition = (POSITION) pNode->pPrev;
        return pNode->data;
}

inline CMyEditTypeInfo* CMyEditTypeInfoList::GetAt(POSITION position)
{
        CNode* pNode = (CNode*) position;
        ASSERT(AfxIsValidAddress(pNode, sizeof(CNode)));
        return &pNode->data;
}

inline CMyEditTypeInfo CMyEditTypeInfoList::GetAt(POSITION position) const
{
        CNode* pNode = (CNode*) position;
        ASSERT(AfxIsValidAddress(pNode, sizeof(CNode)));
        return pNode->data;
}

inline void CMyEditTypeInfoList::SetAt(POSITION pos, const CMyEditTypeInfo* newElement)
{
        CNode* pNode = (CNode*) pos;
        ASSERT(AfxIsValidAddress(pNode, sizeof(CNode)));
        pNode->data = *newElement;
}
