// MyEditView.cpp : ʵļ
//

#include "stdafx.h"
#include "App.h"
#include "AppFrame.h"
#include "AppGlobals.h"
#include "AppSettings.h"
#include "DlgFind.h"
#include "DlgReplace.h"
#include "MyEditView.h"

/////////////////////////////////////////////////////////////////////////////
// CMyEditView
IMPLEMENT_DYNCREATE(CMyEditView, CPfxEditView)
BEGIN_MESSAGE_MAP(CMyEditView, CPfxEditView)
        ON_UPDATE_COMMAND_UI(ID_INDICATOR_CURRENT_CHAR,        OnUpdateGroupStatusBar)
        ON_UPDATE_COMMAND_UI(ID_INDICATOR_CURRENT_POSITION,    OnUpdateGroupStatusBar)
        ON_UPDATE_COMMAND_UI(ID_INDICATOR_DOC_SIZE,            OnUpdateGroupStatusBar)
        ON_UPDATE_COMMAND_UI(ID_INDICATOR_SEL_SIZE,            OnUpdateGroupStatusBar)
        ON_UPDATE_COMMAND_UI(ID_INDICATOR_FILE_FORMAT,         OnUpdateGroupStatusBar)
        ON_UPDATE_COMMAND_UI(ID_INDICATOR_OVERRIDE,            OnUpdateGroupStatusBar)
        ON_UPDATE_COMMAND_UI(ID_INDICATOR_READ_ONLY,           OnUpdateGroupStatusBar)

        ON_UPDATE_COMMAND_UI(ID_FILE_SAVE,                     OnUpdateGroupFile)
        ON_UPDATE_COMMAND_UI(ID_FILE_PRINT,                    OnUpdateGroupFile)
        ON_UPDATE_COMMAND_UI(ID_FILE_PRINT_PREVIEW,            OnUpdateGroupFile)
        ON_UPDATE_COMMAND_UI(ID_FILE_RELOAD,                   OnUpdateGroupFile)

        ON_UPDATE_COMMAND_UI(ID_EDIT_UNDO,                     OnUpdateGroupEdit)
        ON_UPDATE_COMMAND_UI(ID_EDIT_REDO,                     OnUpdateGroupEdit)
        ON_UPDATE_COMMAND_UI(ID_EDIT_COPY,                     OnUpdateGroupEdit)
        ON_UPDATE_COMMAND_UI(ID_EDIT_COPY_APPEND,              OnUpdateGroupEdit)
        ON_UPDATE_COMMAND_UI(ID_EDIT_CUT,                      OnUpdateGroupEdit)
        ON_UPDATE_COMMAND_UI(ID_EDIT_CUT_APPEND,               OnUpdateGroupEdit)
        ON_UPDATE_COMMAND_UI(ID_EDIT_PASTE,                    OnUpdateGroupEdit)
        ON_UPDATE_COMMAND_UI(ID_EDIT_CLEAR,                    OnUpdateGroupEdit)
        ON_UPDATE_COMMAND_UI(ID_EDIT_CLEAR_TO_START_OF_LINE,   OnUpdateGroupEdit)
        ON_UPDATE_COMMAND_UI(ID_EDIT_CLEAR_TO_END_OF_LINE,     OnUpdateGroupEdit)
        ON_UPDATE_COMMAND_UI(ID_EDIT_CLEAR_TO_START_OF_DOC,    OnUpdateGroupEdit)
        ON_UPDATE_COMMAND_UI(ID_EDIT_CLEAR_TO_END_OF_DOC,      OnUpdateGroupEdit)
        ON_UPDATE_COMMAND_UI(ID_EDIT_SELECT_ALL,               OnUpdateGroupEdit)
        ON_UPDATE_COMMAND_UI(ID_EDIT_SELECT_TO_START_OF_LINE,  OnUpdateGroupEdit)
        ON_UPDATE_COMMAND_UI(ID_EDIT_SELECT_TO_END_OF_LINE,    OnUpdateGroupEdit)
        ON_UPDATE_COMMAND_UI(ID_EDIT_SELECT_TO_START_OF_DOC,   OnUpdateGroupEdit)
        ON_UPDATE_COMMAND_UI(ID_EDIT_SELECT_TO_END_OF_DOC,     OnUpdateGroupEdit)
        ON_UPDATE_COMMAND_UI(ID_EDIT_COLUMN_SELECT,            OnUpdateGroupEdit)
        ON_UPDATE_COMMAND_UI(ID_EDIT_COLUMN_PASTE_ALIGN,       OnUpdateGroupEdit)
        ON_UPDATE_COMMAND_UI(ID_EDIT_COLUMN_PASTE_APPEND,      OnUpdateGroupEdit)
        ON_UPDATE_COMMAND_UI(ID_EDIT_CASE_LOWER,               OnUpdateGroupEdit)
        ON_UPDATE_COMMAND_UI(ID_EDIT_CASE_UPPER,               OnUpdateGroupEdit) 
        ON_UPDATE_COMMAND_UI(ID_EDIT_CASE_CAPITALIZE,          OnUpdateGroupEdit) 
        ON_UPDATE_COMMAND_UI(ID_EDIT_CASE_INVERT,              OnUpdateGroupEdit) 
        ON_UPDATE_COMMAND_UI(ID_EDIT_SPACES_TO_TABS,           OnUpdateGroupEdit) 
        ON_UPDATE_COMMAND_UI(ID_EDIT_SPACES_TO_TABS_LEADING,   OnUpdateGroupEdit) 
        ON_UPDATE_COMMAND_UI(ID_EDIT_TABS_TO_SPACES,           OnUpdateGroupEdit) 
        ON_UPDATE_COMMAND_UI(ID_EDIT_TRIM_TRAILING_SPACES,     OnUpdateGroupEdit) 
        ON_UPDATE_COMMAND_UI(ID_EDIT_MATCH_BRACE,              OnUpdateGroupEdit)
        ON_UPDATE_COMMAND_UI(ID_EDIT_SET_WORD_WRAP,            OnUpdateGroupEdit)
        ON_UPDATE_COMMAND_UI(ID_EDIT_SET_READ_ONLY,            OnUpdateGroupEdit)

        ON_UPDATE_COMMAND_UI(ID_VIEW_LINE_NUMBER,              OnUpdateGroupView)
        ON_UPDATE_COMMAND_UI(ID_VIEW_LINE_BREAK,               OnUpdateGroupView)
        ON_UPDATE_COMMAND_UI(ID_VIEW_WHITE_SPACE,              OnUpdateGroupView)
        ON_UPDATE_COMMAND_UI(ID_VIEW_RULER,                    OnUpdateGroupView)

        ON_UPDATE_COMMAND_UI(ID_SEARCH_FIND,                   OnUpdateGroupSearch)
	ON_UPDATE_COMMAND_UI(ID_SEARCH_REPLACE,                OnUpdateGroupSearch)
        ON_UPDATE_COMMAND_UI(ID_SEARCH_FIND_NEXT,              OnUpdateGroupSearch)
	ON_UPDATE_COMMAND_UI(ID_SEARCH_FIND_PREV,              OnUpdateGroupSearch)
        ON_UPDATE_COMMAND_UI(ID_SEARCH_TOGGLE_BOOKMARK,        OnUpdateGroupSearch)
        ON_UPDATE_COMMAND_UI(ID_SEARCH_PREV_BOOKMARK,          OnUpdateGroupSearch)
        ON_UPDATE_COMMAND_UI(ID_SEARCH_NEXT_BOOKMARK,          OnUpdateGroupSearch)
        ON_UPDATE_COMMAND_UI(ID_SEARCH_CLEAR_ALL_BOOKMARKS,    OnUpdateGroupSearch)

	ON_COMMAND(ID_FILE_PRINT,                              OnGroupFile)
        ON_COMMAND(ID_FILE_PRINT_PREVIEW,                      OnGroupFile)
        ON_COMMAND(ID_FILE_RELOAD,                             OnGroupFile)

        ON_COMMAND(ID_EDIT_UNDO,                               OnGroupEdit)
        ON_COMMAND(ID_EDIT_REDO,                               OnGroupEdit)
        ON_COMMAND(ID_EDIT_COPY,                               OnGroupEdit)
        ON_COMMAND(ID_EDIT_COPY_APPEND,                        OnGroupEdit)
        ON_COMMAND(ID_EDIT_CUT,                                OnGroupEdit)
        ON_COMMAND(ID_EDIT_CUT_APPEND,                         OnGroupEdit)
        ON_COMMAND(ID_EDIT_PASTE,                              OnGroupEdit)
        ON_COMMAND(ID_EDIT_CLEAR,                              OnGroupEdit)
        ON_COMMAND(ID_EDIT_CLEAR_TO_START_OF_LINE,             OnGroupEdit)
        ON_COMMAND(ID_EDIT_CLEAR_TO_END_OF_LINE,               OnGroupEdit)
        ON_COMMAND(ID_EDIT_CLEAR_TO_START_OF_DOC,              OnGroupEdit)
        ON_COMMAND(ID_EDIT_CLEAR_TO_END_OF_DOC,                OnGroupEdit)
        ON_COMMAND(ID_EDIT_SELECT_ALL,                         OnGroupEdit)
        ON_COMMAND(ID_EDIT_SELECT_TO_START_OF_LINE,            OnGroupEdit)
        ON_COMMAND(ID_EDIT_SELECT_TO_END_OF_LINE,              OnGroupEdit)
        ON_COMMAND(ID_EDIT_SELECT_TO_START_OF_DOC,             OnGroupEdit)
        ON_COMMAND(ID_EDIT_SELECT_TO_END_OF_DOC,               OnGroupEdit)
        ON_COMMAND(ID_EDIT_COLUMN_SELECT,                      OnGroupEdit)
        ON_COMMAND(ID_EDIT_COLUMN_PASTE_ALIGN,                 OnGroupEdit)
        ON_COMMAND(ID_EDIT_COLUMN_PASTE_APPEND,                OnGroupEdit)
        
        ON_COMMAND(ID_EDIT_CASE_LOWER,                         OnGroupEdit)
        ON_COMMAND(ID_EDIT_CASE_UPPER,                         OnGroupEdit) 
        ON_COMMAND(ID_EDIT_CASE_CAPITALIZE,                    OnGroupEdit) 
        ON_COMMAND(ID_EDIT_CASE_INVERT,                        OnGroupEdit) 

        ON_COMMAND(ID_EDIT_SPACES_TO_TABS,                     OnGroupEdit) 
        ON_COMMAND(ID_EDIT_SPACES_TO_TABS_LEADING,             OnGroupEdit) 
        ON_COMMAND(ID_EDIT_TABS_TO_SPACES,                     OnGroupEdit) 
        ON_COMMAND(ID_EDIT_TRIM_TRAILING_SPACES,               OnGroupEdit)
	ON_COMMAND(ID_EDIT_MATCH_BRACE,                        OnGroupEdit)

        ON_COMMAND(ID_EDIT_SET_READ_ONLY,                      OnGroupEdit)
        ON_COMMAND(ID_EDIT_SET_WORD_WRAP,                      OnGroupEdit)

        ON_COMMAND(ID_VIEW_RULER,                              OnGroupView)
        ON_COMMAND(ID_VIEW_LINE_NUMBER,                        OnGroupView)
        ON_COMMAND(ID_VIEW_LINE_BREAK,                         OnGroupView)
        ON_COMMAND(ID_VIEW_WHITE_SPACE,                        OnGroupView)

	ON_COMMAND(ID_SEARCH_FIND,                             OnGroupSearch)
	ON_COMMAND(ID_SEARCH_REPLACE,                          OnGroupSearch)
	ON_COMMAND(ID_SEARCH_FIND_NEXT,                        OnGroupSearch)
	ON_COMMAND(ID_SEARCH_FIND_PREV,                        OnGroupSearch)
        ON_COMMAND(ID_SEARCH_TOGGLE_BOOKMARK,                  OnGroupSearch)
        ON_COMMAND(ID_SEARCH_PREV_BOOKMARK,                    OnGroupSearch)
        ON_COMMAND(ID_SEARCH_NEXT_BOOKMARK,                    OnGroupSearch)
        ON_COMMAND(ID_SEARCH_CLEAR_ALL_BOOKMARKS,              OnGroupSearch)

        ON_WM_CONTEXTMENU()
END_MESSAGE_MAP()

CMyEditView::CMyEditView()
{
}

CMyEditView::~CMyEditView()
{
}

BOOL CMyEditView::PreCreateWindow(CREATESTRUCT& cs)
{
        // TODO: ڴרô/û
        // ڴֱCSplitterWndṩֻҪˮƽ
        BOOL bResult = CPfxEditView::PreCreateWindow(cs);
        if (bResult)
        {
                cs.style &= ~WS_VSCROLL;
                cs.style &= ~WS_HSCROLL;
        }
        return bResult;
}

/////////////////////////////////////////////////////////////////////////////
// CMyEditView Ϣ
void CMyEditView::OnContextMenu(CWnd* pWnd, CPoint point) 
{
        UNUSED(pWnd);
        // TODO: Add your message handler code here

        CMenu Menu;
        if (Menu.LoadMenu(IDR_POPUP_MYEDIT))
        {
                GetAppFrame()->CreateShortcutMenu(GetAppFrame(),
                        Menu.GetSubMenu(0),
                        point);
        }
}

/////////////////////////////////////////////////////////////////////////////
// ļ...
void CMyEditView::OnCmdFilePrint()
{
        GetAppFrame()->TextEditPrintInitial(this);
}

void CMyEditView::OnCmdFilePrintPeview()
{
        CView::OnFilePrintPreview();
}

void CMyEditView::OnUpdateGroupFile(CCmdUI* pCmdUI)
{
        BOOL bOn = false;
        switch (pCmdUI->m_nID)
        {
        case ID_FILE_SAVE:
                bOn = !IsReadOnly();
                break;

        case ID_FILE_RELOAD:
                bOn = GetDocument()->IsCanReload();
                break;

        case ID_FILE_PRINT_PREVIEW:
                bOn = true;
                break;
        
        case ID_FILE_PRINT:
                bOn = true;
                break;
        
        default:
                ASSERT(false);
                break;
        }
        pCmdUI->Enable(bOn);
        pCmdUI->SetCheck(UI_UNCHECK);
}

void CMyEditView::OnGroupFile()
{
        switch (GetAppFrame()->GetCurrentCommand())
        {
        case ID_FILE_PRINT_PREVIEW:
                OnCmdFilePrintPeview();
                break;
        
        case ID_FILE_PRINT:
                OnCmdFilePrint();
                break;
        
        case ID_FILE_RELOAD:
                OnCmdFileReload();
                break;
        
        default:
                ASSERT(false);
                break;
        }
}

void CMyEditView::OnCmdFileReload()
{
        CMyEditDoc* pDoc = GetDocument();
        if (!pDoc->IsCanReload())
        {
                return;
        }

        if (appAlert2(IDS_P_QUERY_RELOAD_FILE,
                MB_OKCANCEL | MB_ICONEXCLAMATION | MB_DEFBUTTON2,
                pDoc->GetPathName()) == IDOK)
        {
                pDoc->Reload();
        }
}

/////////////////////////////////////////////////////////////////////////////
// OnEdit...
void CMyEditView::OnUpdateGroupEdit(CCmdUI* pCmdUI)
{
        int  nCheck = UI_UNCHECK;
        BOOL bOn;
        BOOL bReadOnly = IsReadOnly();
        BOOL bNotEmpty = (GetDocSize() > 0);

        switch (pCmdUI->m_nID)
        {
        case ID_EDIT_UNDO:
                bOn = IsCanUndo();
                break;
 
        case ID_EDIT_REDO:
                bOn = IsCanRedo();
                break;
        
        case ID_EDIT_COPY:
        case ID_EDIT_COPY_APPEND:
                bOn = IsCanCopy();
                break;

        case ID_EDIT_CUT:
        case ID_EDIT_CUT_APPEND:
                bOn = IsCanCut();
                break;
        
        case ID_EDIT_PASTE:
                bOn = IsCanPaste();
                break;

        // ûݾ޴Ӳ
        case ID_EDIT_CLEAR:
        case ID_EDIT_CLEAR_TO_START_OF_LINE:
        case ID_EDIT_CLEAR_TO_END_OF_LINE:
        case ID_EDIT_CLEAR_TO_START_OF_DOC:
        case ID_EDIT_CLEAR_TO_END_OF_DOC:
                bOn = IsCanDelete();
                break;
        
        case ID_EDIT_SELECT_TO_START_OF_LINE:
        case ID_EDIT_SELECT_TO_END_OF_LINE:
        case ID_EDIT_SELECT_TO_START_OF_DOC:
        case ID_EDIT_SELECT_TO_END_OF_DOC:
        case ID_EDIT_SELECT_ALL:
                bOn = bNotEmpty;
                break;
        
        case ID_EDIT_CASE_LOWER:
        case ID_EDIT_CASE_UPPER:
        case ID_EDIT_CASE_CAPITALIZE:
        case ID_EDIT_CASE_INVERT:

        case ID_EDIT_SPACES_TO_TABS:
        case ID_EDIT_TABS_TO_SPACES:
        case ID_EDIT_SPACES_TO_TABS_LEADING:
        case ID_EDIT_TRIM_TRAILING_SPACES:
                bOn = bNotEmpty && !bReadOnly;
                break;

        case ID_EDIT_COLUMN_SELECT:
                bOn = IsCanColumnSelect();
                break;

        case ID_EDIT_COLUMN_PASTE_ALIGN:
        case ID_EDIT_COLUMN_PASTE_APPEND:
                bOn = IsCanColumnPaste();
                break;

        case ID_EDIT_MATCH_BRACE:
                bOn = bNotEmpty; // will be change...
                break;

        case ID_EDIT_SET_WORD_WRAP:
                bOn = true;
                nCheck = (IsWrapping() ? UI_CHECK : UI_UNCHECK);
                pCmdUI->SetCheck(nCheck);
                break;

        case ID_EDIT_SET_READ_ONLY:
                bOn = true;
                nCheck = (IsReadOnly() ? UI_CHECK : UI_UNCHECK);
                pCmdUI->SetCheck(nCheck);
                break;

        default:
                bOn = false;
                break;
        }
        pCmdUI->Enable(bOn);
}

void CMyEditView::OnGroupEdit()
{
        ASSERT_VALID(this);
        CAppFrame* pAppFrame = GetAppFrame();

        switch (pAppFrame->GetCurrentCommand())
        {
        case ID_EDIT_UNDO:
                OnCmdEditUndo();
                break;
        
        case ID_EDIT_REDO:
                OnCmdEditRedo();
                break;
        
        case ID_EDIT_COPY:
                OnCmdEditCopy();
                break;
        
        case ID_EDIT_COPY_APPEND:
                OnCmdEditCopyAppend();
                break;
        
        case ID_EDIT_CUT:
                OnCmdEditCut();
                break;
        
        case ID_EDIT_CUT_APPEND:
                OnCmdEditCutAppend();
                break;
        
        case ID_EDIT_PASTE:
                OnCmdEditPaste();
                break;

        case ID_EDIT_CLEAR:
                OnCmdEditClear();
                break;
        
        case ID_EDIT_CLEAR_TO_START_OF_LINE:
                OnCmdEditClearToStartOfLine();
                break;
        
        case ID_EDIT_CLEAR_TO_START_OF_DOC:
                OnCmdEditClearToStartOfDoc();
                break;
        
        case ID_EDIT_CLEAR_TO_END_OF_LINE:
                OnCmdEditClearToEndOfLine();
                break;

        case ID_EDIT_CLEAR_TO_END_OF_DOC:
                OnCmdEditClearToEndOfDoc();
                break;
    
        case ID_EDIT_SELECT_ALL:
                OnCmdEditSelectAll();
                break;

        case ID_EDIT_SELECT_TO_START_OF_LINE:
                OnCmdEditSelectToStartOfLine();
                break;
        
        case ID_EDIT_SELECT_TO_START_OF_DOC:
                OnCmdEditSelectToStartOfDoc();
                break;
        
        case ID_EDIT_SELECT_TO_END_OF_LINE:
                OnCmdEditSelectToEndOfLine();
                break;

        case ID_EDIT_SELECT_TO_END_OF_DOC:
                OnCmdEditSelectToEndOfDoc();
                break;

        case ID_EDIT_COLUMN_SELECT:
                OnCmdEditColumnSelect();
                break;

        case ID_EDIT_COLUMN_PASTE_ALIGN:
                OnCmdEditColumnPasteAlign();
                break;
        
        case ID_EDIT_COLUMN_PASTE_APPEND:
                OnCmdEditColumnPasteAppend();
                break;

        case ID_EDIT_SPACES_TO_TABS:
                OnCmdEditSpacesToTabs();
                break;

        case ID_EDIT_SPACES_TO_TABS_LEADING:
                OnCmdEditSpacesToTabsLeading();
                break;

        case ID_EDIT_TABS_TO_SPACES:
                OnCmdEditTabsToSpaces();
                break;

        case ID_EDIT_TRIM_TRAILING_SPACES:
                OnCmdEditTrimTrailingSpaces();
                break;

        case ID_EDIT_CASE_LOWER:
                OnCmdEditCaseLower();
                break;

        case ID_EDIT_CASE_UPPER:
                OnCmdEditCaseUpper();
                break;

        case ID_EDIT_CASE_CAPITALIZE:
                OnCmdEditCaseCapitalize();
                break;

        case ID_EDIT_CASE_INVERT:
                OnCmdEditCaseInvert();
                break;
                
        case ID_EDIT_MATCH_BRACE:
                OnCmdEditMatchBrace();
                break;

        case ID_EDIT_SET_WORD_WRAP:
                OnCmdEditSetWordWrap();
                break;

        case ID_EDIT_SET_READ_ONLY:
                OnCmdEditSetReadOnly();
                break;

        default:
                break;
        }
}

void CMyEditView::OnCmdEditSetWordWrap()            
{ 
        const CPfxEditTypeInfo* pInfo = GetDocument()->GetTypeInfoPtr(); 
        SetViewWrapping(
                (IsWrapping() ? PFX_EC_WRAP_NONE : pInfo->m_nWrapStyle),
                (IsWrapping() ? 0 : pInfo->m_nWrapWidth)); 
}

/////////////////////////////////////////////////////////////////////////////
// OnView...
void CMyEditView::OnUpdateGroupView(CCmdUI* pCmdUI)
{
        // TODO: ڴ˴Ϣ
        
        // ԡ鿴ʽģ
        /*
        if ((pCmdUI->m_nID >= ID_VIEW_FILE_AS_COMMAND_BASE)
                && (pCmdUI->m_nID <= ID_VIEW_FILE_AS_COMMAND_MAX))
        {
                int nCheck = UI_UNCHECK;
                if (GetAppSettings()->FileViewAsGetTypeInfoFromID(pCmdUI->m_nID)
                        == GetDocument()->GetFileTypeInfo())
                {
                        nCheck = UI_CHECK;
                }
                pCmdUI->SetCheck(nCheck);
                pCmdUI->Enable(true);
                return;
        }
        */

        int nCheck;
        BOOL bOn = true;
        switch (pCmdUI->m_nID)
        {
        case ID_VIEW_RULER:
                nCheck = (IsDrawRuler() ? UI_CHECK : UI_UNCHECK);
                pCmdUI->SetCheck(nCheck);
                break;
        
        case ID_VIEW_LINE_NUMBER:
                nCheck = (IsDrawLineNumber() ? UI_CHECK : UI_UNCHECK);
                pCmdUI->SetCheck(nCheck);
                break;
        
        case ID_VIEW_WHITE_SPACE:
                nCheck = (IsDrawWhitespace() ? UI_CHECK : UI_UNCHECK);
                pCmdUI->SetCheck(nCheck);
                break;
        
        case ID_VIEW_LINE_BREAK:
                nCheck = (IsDrawLineBreak() ? UI_CHECK : UI_UNCHECK);
                pCmdUI->SetCheck(nCheck);
                break;

        default:
                bOn = false;
                break;
        }
        
        pCmdUI->Enable(bOn);
}

void CMyEditView::OnGroupView()
{
        ASSERT_VALID(this);
        
        switch (GetAppFrame()->GetCurrentCommand())
        {
        case ID_VIEW_RULER:
                OnCmdViewRuler();
                break;
        
        case ID_VIEW_LINE_NUMBER:
                OnCmdViewLineNumber();
                break;
        
        case ID_VIEW_LINE_BREAK:
                OnCmdViewLineBreak();
                break;
        
        case ID_VIEW_WHITE_SPACE:
                OnCmdViewWhitespace();
                break;

        default:
                break;
        }
}

/*
void CMyEditView::OnCmdViewChangeFileType(UINT nID)
{
        CAppSettings* pAppSettings = GetAppSettings();
        const CMyEditTypeInfo* pFileTypeInfo = pAppSettings->FileViewAsGetTypeInfoFromID(nID);
        if (pFileTypeInfo == NULL)
        {
                return;
        }

        if (GetDocument()->GetFileTypeInfo() != pFileTypeInfo)
        {
                if (pAppSettings->FileTypeInfoLoadDetails(
                        const_cast<CMyEditTypeInfo*>(pFileTypeInfo)))
                {
                        GetDocument()->SetFileTypeInfo(pFileTypeInfo, false);
                }
        }
}
*/
/////////////////////////////////////////////////////////////////////////////
// OnSearch...
void CMyEditView::OnUpdateGroupSearch(CCmdUI* pCmdUI)
{
        // TODO: ڴ˴Ϣ
        BOOL bOn;
        BOOL bReadOnly = IsReadOnly();
        BOOL bNotEmpty = (GetDocSize() > 0);

        switch (pCmdUI->m_nID)
        {
        case ID_SEARCH_FIND:
        case ID_SEARCH_FIND_NEXT:
        case ID_SEARCH_FIND_PREV:
                bOn = bNotEmpty;
                break;
        
        case ID_SEARCH_REPLACE:
                bOn = bNotEmpty && !IsReadOnly();
                break;

        case ID_SEARCH_TOGGLE_BOOKMARK:
                bOn = true;
                break;

        case ID_SEARCH_NEXT_BOOKMARK:
        case ID_SEARCH_PREV_BOOKMARK:
        case ID_SEARCH_CLEAR_ALL_BOOKMARKS:
                bOn = (BookmarkGetCount() > 0);
                break;
        
        default:
                bOn = false;
                break;
        }
        
        pCmdUI->Enable(bOn);
}

void CMyEditView::OnGroupSearch()
{
        ASSERT_VALID(this);

        switch (GetAppFrame()->GetCurrentCommand())
        {
        case ID_SEARCH_TOGGLE_BOOKMARK:
                OnCmdSearchToggleBookmark();
                break;

        case ID_SEARCH_CLEAR_ALL_BOOKMARKS:
                OnCmdSearchClearAllBookmarks();
                break;

        case ID_SEARCH_PREV_BOOKMARK:
                OnCmdSearchGotoPrevBookmark();
                break;
        
        case ID_SEARCH_NEXT_BOOKMARK:
                OnCmdSearchGotoNextBookmark();
                break;
        
        case ID_SEARCH_FIND:
                OnCmdSearchFind();
                break;

        case ID_SEARCH_REPLACE:
                OnCmdSearchReplace();
                break;
        
        case ID_SEARCH_FIND_NEXT:
                OnCmdSearchFindNext();
                break;

        case ID_SEARCH_FIND_PREV:
                OnCmdSearchFindPrev();
                break;
        
        default:
                break;
        }
}

void CMyEditView::OnCmdSearchReplace() 
{
	// TODO: ڴ˴Ϣ
        CDlgReplace dlg;
        dlg.DoModal();
}

void CMyEditView::OnCmdSearchFind() 
{
	// TODO: ڴ˴Ϣ
        CDlgFind dlg;
        dlg.DoModal();
}

void CMyEditView::OnCmdSearchFindNext() 
{
	// TODO: ڴ˴Ϣ
        CAppSettings* pAppSettings = GetAppSettings();
        CString strFindWhat = pAppSettings->SearchGetFindWhatString();
        if (strFindWhat.IsEmpty())
        {
                AfxMessageBox(IDS_P_SEARCH_NO_FIND_WHAT_STRING, MB_OK);
                return;
        }

        BOOL bMatchCase       = pAppSettings->SearchIsMatchCase();
        BOOL bMatchWholeWord  = pAppSettings->SearchIsMatchWholeWord();

        CPoint ptFrom = GetCurrentPosition();
        CPoint ptTo(0, 0);

        // ǰѡݾҪҵĶ򱾴βҲλý
        // ѡݵĺһַ
        if (IsTextSelected() && !IsColumnSelect())
        {
                CPoint ptSelFrom;
                CPoint ptSelTo;
                GetSelRange(ptSelFrom, ptSelTo);

                if (EditFind(ptSelFrom,
                        ptSelTo,
                        strFindWhat,
                        -1,
                        bMatchCase,
                        bMatchWholeWord,
                        false,  // RegExp
                        true,   // bDirectDown
                        false,  // bMarkAll
                        false)) // bWrapAtEndOfFile
                {
                        GetSelRange(ptSelFrom, ptSelTo);
                        ptFrom = ptSelTo; // λȡѡΧĩˡ
                }
        }

        if (EditFind(ptFrom,
                ptTo,
                strFindWhat,
                -1,
                bMatchCase,
                bMatchWholeWord,
                false,
                true,   // bDirectDown
                false,  // bMarkAll
                true))  // bWrapAtEndOfFile
        {
                EditSelect(ptFrom.y, ptFrom.x, ptTo.y, ptTo.x);
        }
        else
        {
                EditSelect(-1, 0, -1, 0);
                
                appAlert2(IDS_P_SEARCH_STRING_NOT_FOUND,
                        MB_OK | MB_ICONEXCLAMATION,
                        strFindWhat);
        }
}

void CMyEditView::OnCmdSearchFindPrev() 
{
	// TODO: ڴ˴Ϣ
        CAppSettings* pAppSettings = GetAppSettings();
        CString strFindWhat = pAppSettings->SearchGetFindWhatString();
        if (strFindWhat.IsEmpty())
        {
                AfxMessageBox(IDS_P_SEARCH_NO_FIND_WHAT_STRING, MB_OK);
                return;
        }

        BOOL bMatchCase       = pAppSettings->SearchIsMatchCase();
        BOOL bMatchWholeWord  = pAppSettings->SearchIsMatchWholeWord();
        BOOL bDirectDown      = false;
        BOOL bMarkAll         = false;
        BOOL bWrapAtEndOfFile = true;

        CPoint ptFrom = GetCurrentPosition();
        CPoint ptTo(0, 0);

        // ǰѡݾҪҵĶ򱾴βҲλý
        // ѡݵĺһַ
        if (IsTextSelected() && !IsColumnSelect())
        {
                CPoint ptSelFrom;
                CPoint ptSelTo;
                GetSelRange(ptSelFrom, ptSelTo);

                if (EditFind(ptSelFrom,
                        ptSelTo,
                        strFindWhat,
                        -1,
                        bMatchCase,
                        bMatchWholeWord,
                        false,
                        true,   // bDirectDown
                        false,  // bMarkAll
                        false)) // bWrapAtEndOfFile
                {
                        GetSelRange(ptSelFrom, ptSelTo);
                        ptFrom = ptSelFrom; // λȡѡΧĩˡ
                }
        }

        if (EditFind(ptFrom,
                ptTo,
                strFindWhat,
                -1,
                bMatchCase,
                bMatchWholeWord,
                false,
                false,  // bDirectDown
                false,  // bMarkAll
                true))  // bWrapAtEndOfFile
        {
                EditSelect(ptFrom.y, ptFrom.x, ptTo.y, ptTo.x);
        }
        else
        {
                EditSelect(-1, 0, -1, 0);
                
                appAlert2(IDS_P_SEARCH_STRING_NOT_FOUND,
                        MB_OK | MB_ICONEXCLAMATION,
                        strFindWhat);
        }
}

/////////////////////////////////////////////////////////////////////////////
// ״̬...
void CMyEditView::OnUpdateGroupStatusBar(CCmdUI* pCmdUI)
{
        // TODO: ڴ˴Ϣ
        TCHAR szOutMsg[80];
        TCHAR szFormat[64];
        BOOL bEnable = true;
        
        switch (pCmdUI->m_nID)
        {
        default:
                {
                        szOutMsg[0] = '\0';
                        TRACE("Unknown statusbar pane id %d\n", pCmdUI->m_nID);
                }
                break;

        case ID_INDICATOR_OVERRIDE:
                {
                        AfxLoadString(IDS_INDICATOR_TEXT_OVERRIDE,
                                szOutMsg,
                                SIZEOF(szOutMsg));
                        
                        bEnable = IsOverride();
                }
                break;
                
        case ID_INDICATOR_READ_ONLY:
                {
                        AfxLoadString(IDS_INDICATOR_TEXT_READ_ONLY,
                                szOutMsg,
                                SIZEOF(szOutMsg));
                        
                        bEnable = IsReadOnly();
                }
                break;
                
        case ID_INDICATOR_CURRENT_CHAR:
                {
                        LONG ch = GetCurrentChar() & USHRT_MAX;
                        AfxLoadString(IDS_INDICATOR_TEXT_CURRENT_CHAR,
                                szFormat,
                                SIZEOF(szFormat));
                        _stprintf(szOutMsg, szFormat, ch, ch);
                }
                break;
        
        case ID_INDICATOR_CURRENT_POSITION:
                {
                        CPoint pt = GetCurrentPosition(true);

                        AfxLoadString(IDS_INDICATOR_TEXT_CURRENT_POSITION,
                                szFormat,
                                SIZEOF(szFormat));
                
                        _stprintf(szOutMsg, szFormat, (pt.y + 1), (pt.x + 1));
                
                        bEnable = true;
                }
                break;
                
        case ID_INDICATOR_DOC_SIZE:
                {
                        UINT nID;
                        UINT nSize;
                        if (!IsTextSelected())
                        {
                                nID = IDS_INDICATOR_TEXT_DOC_SIZE;
                                nSize = GetDocSize();
                        }
                        else
                        {
                                nID = IDS_INDICATOR_TEXT_SEL_SIZE;
                                nSize = GetSelSize(GetLineBreakType());
                        }
                        
                        AfxLoadString(nID, szFormat, SIZEOF(szFormat));
                        _stprintf(szOutMsg, szFormat, nSize);
                        
                        bEnable = true;
                }
                
                break;
                
        case ID_INDICATOR_FILE_FORMAT:
                {
                        UINT nIDLineBreakType;
                        UINT nIDFileConverter;
                        switch (GetDocument()->GetLineBreakType())
                        {
                        case PFX_EC_LINE_BREAK_TYPE_UNIX:
                                nIDLineBreakType = IDS_INDICATOR_TEXT_FILE_FORMAT_LINE_BREAK_TYPE_UNIX;
                                break;
                                
                        case PFX_EC_LINE_BREAK_TYPE_MAC:
                                nIDLineBreakType = IDS_INDICATOR_TEXT_FILE_FORMAT_LINE_BREAK_TYPE_MAC;
                                break;
                                
                        case PFX_EC_LINE_BREAK_TYPE_DOS:
                        default:
                                nIDLineBreakType = IDS_INDICATOR_TEXT_FILE_FORMAT_LINE_BREAK_TYPE_DOS;
                                break;
                        }
                        
                        switch (GetDocument()->GetFileConverter())
                        {
                        default:
                        case PFX_EC_FILE_CONVERTER_ANSI:
                                nIDFileConverter = IDS_INDICATOR_TEXT_FILE_FORMAT_FILE_CONVERTER_ANSI;
                                break;

                        case PFX_EC_FILE_CONVERTER_UTF8:
                                nIDFileConverter = IDS_INDICATOR_TEXT_FILE_FORMAT_FILE_CONVERTER_UTF8;
                                break;

                        case PFX_EC_FILE_CONVERTER_UNICODE:
                                nIDFileConverter = IDS_INDICATOR_TEXT_FILE_FORMAT_FILE_CONVERTER_UNICODE;
                                break;

                        case PFX_EC_FILE_CONVERTER_UNICODE_BIG_ENDIAN:
                                nIDFileConverter = IDS_INDICATOR_TEXT_FILE_FORMAT_FILE_CONVERTER_UNICODE_BIG_ENDIAN;
                                break;
                        }

                        TCHAR szLineBreakType[128];
                        TCHAR szFileConverter[128];
                        AfxLoadString(nIDLineBreakType,
                                szLineBreakType,
                                SIZEOF(szLineBreakType));
                        
                        AfxLoadString(nIDFileConverter,
                                szFileConverter,
                                SIZEOF(szFileConverter));
                        
                        AfxLoadString(IDS_INDICATOR_TEXT_FILE_FORMAT,
                                szFormat,
                                SIZEOF(szFormat));

                        _stprintf(szOutMsg,
                                szFormat,
                                szLineBreakType,
                                szFileConverter);
                        
                        bEnable = true;
                }
                break;
        }

        pCmdUI->Enable(bEnable);
        pCmdUI->SetText(szOutMsg);
}

/////////////////////////////////////////////////////////////////////////////
BOOL CMyEditView::OnPreparePrinting(CPrintInfo* pInfo) 
{
        ASSERT(pInfo != NULL);
        ASSERT(pInfo->m_pPD != NULL);
        
        // TODO: call DoPreparePrinting to invoke the Print dialog box
        PRINTDLG* pPD = &pInfo->m_pPD->m_pd;
        if (pPD->nMinPage > pPD->nMaxPage)
        {
                pPD->nMaxPage = pPD->nMinPage;
        }

        ASSERT(pPD->hDC == NULL);
        pPD->nFromPage = (WORD)pInfo->GetMinPage();
        pPD->nToPage   = (WORD)pInfo->GetMaxPage();

        // if no printer set then, get default printer DC and create DC
        // without calling print dialog.
	CWinApp* pApp = AfxGetApp();
        if (!pApp->GetPrinterDeviceDefaults(pPD))
        {
                // bring up dialog to alert the user they need to install
                // a printer.
                if ((pInfo->m_dwFlags & PRINTFLAG_MAYBOTHERUSER)
                        || (pInfo->m_bPreview))
                {
                        if (pApp->DoPrintDialog(pInfo->m_pPD) != IDOK)
                        {
                                return false;
                        }
                }
        }

        ASSERT(pPD->hDC == NULL);

        // call CreatePrinterDC if DC was not created by above
        if (pInfo->m_pPD->CreatePrinterDC() == NULL)
        {
                return false;
        }
        
        ASSERT(pInfo->m_pPD != NULL);
        ASSERT(pInfo->m_pPD->m_pd.hDC != NULL);

        pInfo->m_nNumPreviewPages = pApp->m_nNumPreviewPages;
	VERIFY(pInfo->m_strPageDesc.LoadString(AFX_IDS_PREVIEWPAGEDESC));
        
        return true;
}

BOOL CMyEditView::OnSetupPrintInfo(CPfxEditPrintInfo* pPrintInfo)
{
        const CMyEditPrintInfo& rInfo = GetAppSettings()->PrintingGetInfo();

        // ӳĻ塣
        pPrintInfo->SetMapDisplayFont();
 
        // ʾ˫ӡӦñִӡԻ򲻹رգΪ
        // ûѾӡֽŷҿԱ֤δӡʱһ¡
        GetSystemTime(&pPrintInfo->m_time);

        // ʾ򣺴ӡҳѡҳżҳżҳӡ
        pPrintInfo->SetPrintPagesAll();

        // ҳ뷶Χ
        pPrintInfo->m_nFromPage = rInfo.m_nPageFrom;
        pPrintInfo->m_nToPage   = rInfo.m_nPageTo;

        // ҳ߾࣬ǴӡöԻʹ1/100MMλʹCMΪλ
        FLOAT fL = static_cast<FLOAT>(rInfo.m_rectMargin.left / 1000);
        FLOAT fT = static_cast<FLOAT>(rInfo.m_rectMargin.top / 1000);
        FLOAT fR = static_cast<FLOAT>(rInfo.m_rectMargin.right / 1000);
        FLOAT fB = static_cast<FLOAT>(rInfo.m_rectMargin.bottom / 1000);
        
        CRect rectMargin;
        rectMargin.left   = pPrintInfo->PrinterLogicUnitFromCmX(fL);
        rectMargin.top    = pPrintInfo->PrinterLogicUnitFromCmY(fT);
        rectMargin.right  = pPrintInfo->PrinterLogicUnitFromCmX(fR);
        rectMargin.bottom = pPrintInfo->PrinterLogicUnitFromCmY(fB);

        pPrintInfo->m_rectMargin.CopyRect(&rectMargin);
        pPrintInfo->m_nSpacingHeaderAndText = pPrintInfo->PrinterLogicUnitFromCmY((FLOAT)0.2);
        pPrintInfo->m_nSpacingFooterAndText = pPrintInfo->PrinterLogicUnitFromCmY((FLOAT)0.2);

        pPrintInfo->m_strHeader = rInfo.m_strHeader;
        pPrintInfo->m_strFooter = rInfo.m_strFooter;
        
        // Ƿӡ﷨
        pPrintInfo->m_bPrintHilighted = true;
        pPrintInfo->m_bPrintHeaderSeparator = true;
        pPrintInfo->m_bPrintFooterSeparator = true;

        pPrintInfo->m_penSeparateLine.CreatePen(PS_SOLID, 
                pPrintInfo->PrinterLogicUnitFromDisplayX(1),
                pPrintInfo->COLOR(kcHeaderAndFooter));

        // Ԥҳ߾߿
        if (pPrintInfo->IsPreview())
        {
                CPen* pPenMargin = pPrintInfo->GetPenMargin();
                pPenMargin->CreatePen(PS_DOT,
                        0,
                        (COLORREF)GetSysColor(COLOR_BTNSHADOW));
        }

        // һĵƣΪĵѾ޸ģڱ⴦һ*
        // ָʾĵѾ޸ģи÷žҪ
        pPrintInfo->m_strPathName.TrimRight();
        pPrintInfo->m_strPathName.TrimRight(STR_MODIFIED_DOCUMENT_TITLE_FLAG);
        return true;
}
