#pragma once
#include "pfx\inc\pfxeditctrl.h"
#include "MyEditDoc.h"
/////////////////////////////////////////////////////////////////////////////
// CMyEditView ͼ
class CMyEditDoc;
class CMyEditView : public CPfxEditView
{
	DECLARE_DYNCREATE(CMyEditView)

protected:
	CMyEditView();           // ̬ʹõܱĹ캯
	virtual        ~CMyEditView();

public:
        CMyEditDoc*    GetDocument() const;

protected:
        void           OnCmdFilePrint();
        void           OnCmdFilePrintPeview();
        void           OnCmdFileReload();

        void           OnCmdEditUndo();
        void           OnCmdEditRedo();
        void           OnCmdEditPaste();
        void           OnCmdEditCopy();
        void           OnCmdEditCopyAppend();
        void           OnCmdEditCut();
        void           OnCmdEditCutAppend();
        void           OnCmdEditClear();
        void           OnCmdEditClearToStartOfLine();
        void           OnCmdEditClearToStartOfDoc();
        void           OnCmdEditClearToEndOfLine();
        void           OnCmdEditClearToEndOfDoc();
        void           OnCmdEditSelectAll();
        void           OnCmdEditSelectToStartOfLine();
        void           OnCmdEditSelectToStartOfDoc();
        void           OnCmdEditSelectToEndOfLine();
        void           OnCmdEditSelectToEndOfDoc();
        void           OnCmdEditColumnSelect();
        void           OnCmdEditColumnPasteAlign();
        void           OnCmdEditColumnPasteAppend();
        void           OnCmdEditSpacesToTabs();
        void           OnCmdEditSpacesToTabsLeading();
        void           OnCmdEditTabsToSpaces();
        void           OnCmdEditTrimTrailingSpaces();
        void           OnCmdEditCaseLower();
        void           OnCmdEditCaseUpper();
        void           OnCmdEditCaseCapitalize();
        void           OnCmdEditCaseInvert();
        void           OnCmdEditMatchBrace();
        void           OnCmdEditSetWordWrap();
        void           OnCmdEditSetReadOnly();

        void           OnCmdViewRuler();
        void           OnCmdViewLineNumber();
        void           OnCmdViewLineBreak();
        void           OnCmdViewWhitespace();

        void           OnCmdSearchFind();
        void           OnCmdSearchFindNext();
        void           OnCmdSearchFindPrev();
        void           OnCmdSearchReplace();
        void           OnCmdSearchToggleBookmark();
        void           OnCmdSearchClearAllBookmarks();
        void           OnCmdSearchGotoPrevBookmark();
        void           OnCmdSearchGotoNextBookmark();

protected:
        virtual BOOL   PreCreateWindow(CREATESTRUCT& cs);
	virtual BOOL   OnPreparePrinting(CPrintInfo* pInfo);
        virtual BOOL   OnSetupPrintInfo(CPfxEditPrintInfo* pPrintInfo);

protected:
	DECLARE_MESSAGE_MAP()
        afx_msg void   OnUpdateGroupFile(CCmdUI* pCmdUI);
        afx_msg void   OnUpdateGroupEdit(CCmdUI* pCmdUI);
        afx_msg void   OnUpdateGroupSearch(CCmdUI* pCmdUI);
        afx_msg void   OnUpdateGroupView(CCmdUI* pCmdUI);
        afx_msg void   OnUpdateGroupStatusBar(CCmdUI* pCmdUI);
        afx_msg void   OnGroupFile();
        afx_msg void   OnGroupEdit();
        afx_msg void   OnGroupView();
        afx_msg void   OnGroupSearch();
        afx_msg void   OnContextMenu(CWnd* pWnd, CPoint point);
};

/////////////////////////////////////////////////////////////////////////////
inline void            CMyEditView::OnCmdEditUndo()                   { EditUndo(); }
inline void            CMyEditView::OnCmdEditRedo()                   { EditRedo(); }
inline void            CMyEditView::OnCmdEditCopy()                   { EditCopy(false); }
inline void            CMyEditView::OnCmdEditCopyAppend()             { EditCopy(true); }
inline void            CMyEditView::OnCmdEditCut()                    { EditCut(false); }
inline void            CMyEditView::OnCmdEditCutAppend()              { EditCut(true); }
inline void            CMyEditView::OnCmdEditPaste()                  { EditPaste(-1, -1); }
inline void            CMyEditView::OnCmdEditClear()                  { EditRemove(-1, 0, -1, 0); }
inline void            CMyEditView::OnCmdEditClearToStartOfLine()     { CPoint pt = GetCurrentPosition(); EditRemove(pt.y, pt.x, pt.y, 0); }
inline void            CMyEditView::OnCmdEditClearToStartOfDoc()      { CPoint pt = GetCurrentPosition(); EditRemove(pt.y, pt.x, 0, 0); }
inline void            CMyEditView::OnCmdEditClearToEndOfLine()       { CPoint pt = GetCurrentPosition(); EditRemove(pt.y, pt.x, pt.y, GetLineLength(pt.y)); }
inline void            CMyEditView::OnCmdEditClearToEndOfDoc()        { CPoint pt = GetCurrentPosition(); EditRemove(pt.y, pt.x, GetLineUpperBound(), GetLineLength(GetLineUpperBound())); }
inline void            CMyEditView::OnCmdEditSelectAll()              { EditSelect(0, 0, -1, 0); }
inline void            CMyEditView::OnCmdEditSelectToStartOfLine()    { CPoint pt = GetCurrentPosition(); EditSelect(pt.y, pt.x, pt.y, 0); }
inline void            CMyEditView::OnCmdEditSelectToStartOfDoc()     { CPoint pt = GetCurrentPosition(); EditSelect(pt.y, pt.x, 0, 0); }
inline void            CMyEditView::OnCmdEditSelectToEndOfLine()      { CPoint pt = GetCurrentPosition(); EditSelect(pt.y, pt.x, pt.y, GetLineLength(pt.y)); }
inline void            CMyEditView::OnCmdEditSelectToEndOfDoc()       { CPoint pt = GetCurrentPosition(); EditSelect(pt.y, pt.x, GetLineUpperBound(), GetLineLength(GetLineUpperBound())); }
inline void            CMyEditView::OnCmdEditColumnSelect()           { SetColumnSelect(); }
inline void            CMyEditView::OnCmdEditColumnPasteAlign()       { EditPaste(-1, -1, PFX_EC_PASTE_COLUMN_ALIGN); }
inline void            CMyEditView::OnCmdEditColumnPasteAppend()      { EditPaste(-1, -1, PFX_EC_PASTE_COLUMN_APPEND); }
inline void            CMyEditView::OnCmdEditSpacesToTabs()           { EditSpacesToTabs(false); }
inline void            CMyEditView::OnCmdEditSpacesToTabsLeading()    { EditSpacesToTabs(true); }
inline void            CMyEditView::OnCmdEditTabsToSpaces()           { EditTabsToSpaces(); }
inline void            CMyEditView::OnCmdEditTrimTrailingSpaces()     { EditTrimTrailingSpaces(); }
inline void            CMyEditView::OnCmdEditCaseLower()              { EditCaseChange(true); }
inline void            CMyEditView::OnCmdEditCaseUpper()              { EditCaseChange(false); }
inline void            CMyEditView::OnCmdEditCaseCapitalize()         { EditCaseCapitalize(); }
inline void            CMyEditView::OnCmdEditCaseInvert()             { EditCaseInvert(); }
inline void            CMyEditView::OnCmdEditMatchBrace()             { if (!EditMatchBrace()) { ::MessageBeep(MB_OK); }}
inline void            CMyEditView::OnCmdEditSetReadOnly()            { SetReadOnly(!IsReadOnly()); }

inline void            CMyEditView::OnCmdViewRuler()                  { SetViewRuler(!IsDrawRuler()); }
inline void            CMyEditView::OnCmdViewLineNumber()             { SetViewLineNumber(!IsDrawLineNumber()); }
inline void            CMyEditView::OnCmdViewLineBreak()              { SetViewLineBreak(!IsDrawLineBreak()); }
inline void            CMyEditView::OnCmdViewWhitespace()             { SetViewWhitespace(!IsDrawWhitespace()); }

inline void            CMyEditView::OnCmdSearchToggleBookmark()       { BookmarkToggle(!IsDrawBookmark()); }
inline void            CMyEditView::OnCmdSearchClearAllBookmarks()    { BookmarkClearAll(); }
inline void            CMyEditView::OnCmdSearchGotoPrevBookmark()     { LONG nLine = BookmarkGetPrev(GetCurrentPosition().y, true); if (nLine != -1) { SetCurrentPosition(nLine, 0); }}
inline void            CMyEditView::OnCmdSearchGotoNextBookmark()     { LONG nLine = BookmarkGetNext(GetCurrentPosition().y, true); if (nLine != -1) { SetCurrentPosition(nLine, 0); }}

/////////////////////////////////////////////////////////////////////////////
//inline void            CMyEditView::SetPrintInfo(const CMyEditPrintInfo* pPrintInfo) { ASSERT(pPrintInfo != NULL); m_pPrintInfo = const_cast<CMyEditPrintInfo*>(pPrintInfo); }
inline CMyEditDoc*     CMyEditView::GetDocument() const               { return static_cast<CMyEditDoc*>(m_pDocument); }
/////////////////////////////////////////////////////////////////////////////
