/////////////////////////////////////////////////////////////////////////////
// ԽԽûˣдú
#include "stdAfx.h"
#include "App.h"
#include "MyEditMisc.h"
#include "MyEditXmlLoader.h"

/////////////////////////////////////////////////////////////////////////////
#pragma comment(lib, "msxml2.lib")

/////////////////////////////////////////////////////////////////////////////
CMyEditXmlLoader::CMyEditXmlLoader()
{
}

CMyEditXmlLoader::~CMyEditXmlLoader()
{
}

/////////////////////////////////////////////////////////////////////////////
void CMyEditXmlLoader::reportError(UINT id)
{
        CMyEditXmlLoaderException* e = new CMyEditXmlLoaderException(id);
        throw e;
}

void CMyEditXmlLoader::reportError(UINT id, int unused, ...)
{
        CString strFormat;
        CString strMessage;

        va_list arglist;
        va_start(arglist, unused);

        strFormat.LoadString(id);
        strMessage.FormatV(strFormat, arglist);

        va_end(arglist);

        CMyEditXmlLoaderException* e = new CMyEditXmlLoaderException(strMessage);
        throw e;
}

bool CMyEditXmlLoader::valueBool(LPCTSTR pszString)
{
        if (pszString != NULL)
        {
                if (isString(pszString, boolTRUE()))
                {
                        return true;
                }

                if (isString(pszString, boolFALSE()))
                {
                        return false;
                }
        }
        return false;
}

COLORREF CMyEditXmlLoader::valueColor(LPCTSTR pszString, COLORREF clrDef)
{
        // ɫַתCOLORREF
        COLORREF clr = clrDef;
        if (pszString != NULL)
        {
                _stscanf(pszString, keyKeywordsClassColorFormat(), &clr);
        }
        return clr;
}

bool CMyEditXmlLoader::isString(LPCTSTR psz1, LPCTSTR psz2)
{
        if ((psz1 == NULL) || (psz2 == NULL))
        {
                return false;
        }
        return (lstrcmp(psz1, psz2) == 0);
}

bool CMyEditXmlLoader::isStringI(LPCTSTR psz1, LPCTSTR psz2)
{
        if ((psz1 == NULL) || (psz2 == NULL))
        {
                return false;
        }
        return (lstrcmpi(psz1, psz2) == 0);
}

void CMyEditXmlLoader::loadSummary(LPCTSTR pszFile, CMyEditTypeInfo* pti)
{
        ASSERT(m_pDoc == NULL);
        ASSERT(pti != NULL);
        ASSERT(!pti->IsLoaded());

        m_pti     = pti;
        m_strFile = pszFile;
        m_pszFile = (LPCTSTR)m_strFile;

        loadDocument();

        CComPtr<IXMLDOMElement>pElement;
        m_pDoc->get_documentElement(&pElement);

        loadLanguage(pElement);
}

void CMyEditXmlLoader::loadDetails(LPCTSTR pszFile, CMyEditTypeInfo* pti)
{
        ASSERT(m_pDoc == NULL);
        ASSERT(pti != NULL);
        ASSERT(!pti->IsLoaded());

        m_pti     = pti;
        m_strFile = pszFile;
        m_pszFile = (LPCTSTR)m_strFile;

        loadDocument();

        CComPtr<IXMLDOMElement>pElement;
        m_pDoc->get_documentElement(&pElement);

        loadLanguage(pElement);

        CComPtr<IXMLDOMNodeList>pNodeList;
        pElement->get_childNodes(&pNodeList);

        long nNodes = 0;
        pNodeList->get_length(&nNodes);
        for (long i = 0; i < nNodes; i++)
        {
                CComPtr<IXMLDOMNode>pNode;
                pNodeList->get_item(i, &pNode);
                
                _bstr_t name;
                pNode->get_baseName(name.GetAddress());
                
                if (isString(name, keySpecific()))
                {
                        loadSpecific(pNode);
                }
                else if (isString(name, keyKeywords()))
                {
                        loadKeywords(pNode);
                }
                else
                {
                        reportError(IDS_E_STX_LOADER_INVALID_STX_FILE,
                                0,
                                m_pszFile);
                }
        }
        
        m_pti->m_bLoaded = true;
        m_pti->SetKeyClassColor(kcQuotedString1, PFX_EC_CLR_QUOTED_STRING1);
        m_pti->SetKeyClassColor(kcQuotedString2, PFX_EC_CLR_QUOTED_STRING2);
        m_pti->SetKeyClassColor(kcLineComment1,  PFX_EC_CLR_LINE_COMMENT1);
        m_pti->SetKeyClassColor(kcLineComment2,  PFX_EC_CLR_LINE_COMMENT2);
        m_pti->SetKeyClassColor(kcBlockComment1, PFX_EC_CLR_BLOCK_COMMENT1);
        m_pti->SetKeyClassColor(kcBlockComment2, PFX_EC_CLR_BLOCK_COMMENT2);
}

void CMyEditXmlLoader::loadDocument()
{
        if (FAILED(m_pDoc.CoCreateInstance(CLSID_DOMDocument2,
                NULL,
                CLSCTX_ALL)))
        {
                reportError(IDS_E_STX_LOADER_FAILED_TO_CREATE_MSXML_OBJECT);
        }

        VARIANT_BOOL bLoadSuccess;
        HRESULT hr = m_pDoc->load(CComVariant(m_pszFile), &bLoadSuccess);
        if (FAILED(hr) || !bLoadSuccess)
        {
                reportError(IDS_E_STX_LOADER_FAILED_TO_LOAD_FILE,
                        0,
                        m_pszFile);
        }
}

void CMyEditXmlLoader::loadLanguage(IXMLDOMElement* pElement)
{
        if (pElement == NULL)
        {
                reportError(IDS_E_STX_LOADER_INVALID_STX_FILE,
                        0,
                        m_pszFile);
        }

        _bstr_t name;
        if (FAILED(pElement->get_baseName(name.GetAddress()))
                || ((LPCTSTR)name == NULL))
        {
                reportError(IDS_E_STX_LOADER_INVALID_STX_FILE,
                        0,
                        m_pszFile);
        }

        CComPtr<IXMLDOMNamedNodeMap>pAttributes;
        if (FAILED(pElement->get_attributes(&pAttributes)))
        {
                reportError(IDS_E_STX_LOADER_INVALID_STX_FILE,
                        0,
                        m_pszFile);
        }
      
        // Title
        {
                CComPtr<IXMLDOMNode>item;
                pAttributes->getNamedItem(
                        _bstr_t(keyLanguageTitle()),
                        &item);
                _bstr_t text;
                item->get_text(text.GetAddress());
                m_pti->m_strTypeDescription = (LPCTSTR)text;
        }

        // Extensions
        {
                CComPtr<IXMLDOMNode>item;
                pAttributes->getNamedItem(
                        _bstr_t(keyLanguageExtensions()),
                        &item);
                _bstr_t text;
                item->get_text(text.GetAddress());
                m_pti->m_strTypeExtensions = (LPCTSTR)text;
        }

        // MatchCase
        {
                CComPtr<IXMLDOMNode>item;
                pAttributes->getNamedItem(
                        _bstr_t(keyLanguageMatchCase()),
                        &item);
                _bstr_t text;
                item->get_text(text.GetAddress());
                m_pti->SetMatchCase(valueBool((LPCTSTR)text));
        }

        // Escape
        {
                CComPtr<IXMLDOMNode>item;
                pAttributes->getNamedItem(
                        _bstr_t(keyLanguageEscape()),
                        &item);
                _bstr_t text;
                item->get_text(text.GetAddress());
                m_pti->SetEscape((LPCTSTR)text);
        }

        // Delimiters
        {
                CComPtr<IXMLDOMNode>item;
                pAttributes->getNamedItem(
                        _bstr_t(keyLanguageDelimiters()),
                        &item);
                _bstr_t text;
                item->get_text(text.GetAddress());
                m_pti->SetDelimiters((LPCTSTR)text);
        }
}

void CMyEditXmlLoader::loadSpecific(IXMLDOMNode* pNode)
{
        ASSERT(pNode != NULL);

        CComPtr<IXMLDOMNodeList>pNodeList;
        pNode->get_childNodes(&pNodeList);
        
        long nNodes = 0;
        pNodeList->get_length(&nNodes);

        for (long i = 0; i < nNodes; i++)
        {
                CComPtr<IXMLDOMNode>pNode;
                pNodeList->get_item(i, &pNode);

                _bstr_t name;
                pNode->get_baseName(name.GetAddress());

                if (isString(name, keySpecificLineComments()))
                {
                        loadLineComments(pNode);
                }
                else if (isString(name, keySpecificBlockComments()))
                {
                        loadBlockComments(pNode);
                }
                else if (isString(name, keySpecificBraceStrings()))
                {
                        loadBraceStrings(pNode);
                }
                else if (isString(name, keySpecificQuotedStrings()))
                {
                        loadQuotedStrings(pNode);
                }
                else
                {
                        reportError(IDS_E_STX_LOADER_INVALID_STX_FILE,
                                0,
                                m_pszFile);
                }
        }
}

void CMyEditXmlLoader::loadKeywords(IXMLDOMNode* pNode)
{
        ASSERT(pNode != NULL);

        CComPtr<IXMLDOMNodeList>pNodeList;
        pNode->get_childNodes(&pNodeList);
        
        long nNodes = 0;
        pNodeList->get_length(&nNodes);

        for (long i = 0; i < nNodes; i++)
        {
                CComPtr<IXMLDOMNode>pNode;
                pNodeList->get_item(i, &pNode);

                CComPtr<IXMLDOMNamedNodeMap>pAttributes;
                pNode->get_attributes(&pAttributes);
                
                CComPtr<IXMLDOMNode>nodeName;
                pAttributes->getNamedItem(
                        _bstr_t(keyKeywordsClassName()),
                        &nodeName);

                CComPtr<IXMLDOMNode>nodeColor;
                pAttributes->getNamedItem(
                        _bstr_t(keyKeywordsClassColor()),
                        &nodeColor);

                _bstr_t strName;
                nodeName->get_text(strName.GetAddress());
                _bstr_t strColor;
                nodeColor->get_text(strColor.GetAddress());
                
                CPfxEditKeyClass theClass(strName, valueColor(strColor));
                LONG cls = m_pti->SetKeyClass(theClass);
                loadKeyword(pNode, cls);
        }
}

void CMyEditXmlLoader::loadKeyword(IXMLDOMNode* pNode, LONG nKeyClass)
{
        CComPtr<IXMLDOMNodeList>pNodeList;
        pNode->get_childNodes(&pNodeList);
        
        long nNodes = 0;
        pNodeList->get_length(&nNodes);

        for (long i = 0; i < nNodes; i++)
        {
                CComPtr<IXMLDOMNode>pNode;
                pNodeList->get_item(i, &pNode);
                
                _bstr_t text;
                pNode->get_text(text.GetAddress());

                if ((LPCTSTR)text != NULL)
                {
                        m_pti->SetKeyword(nKeyClass, text);
                }
        }
}

void CMyEditXmlLoader::loadLineComments(IXMLDOMNode* pNode)
{
        CComPtr<IXMLDOMNodeList>pNodeList;
        pNode->get_childNodes(&pNodeList);
        
        long nNodes = 0;
        pNodeList->get_length(&nNodes);

        for (long i = 0; i < nNodes; i++)
        {
                CComPtr<IXMLDOMNode>pNode;
                pNodeList->get_item(i, &pNode);

                CComPtr<IXMLDOMNamedNodeMap>pAttributes;
                pNode->get_attributes(&pAttributes);
                
                CComPtr<IXMLDOMNode>item;
                pAttributes->getNamedItem(
                        _bstr_t(keySpecificLineCommentsLineCommentOn()),
                        &item);
                
                _bstr_t text;
                item->get_text(text.GetAddress());

                LPCTSTR psz = text;
                if (i == 0)
                {
                        m_pti->SetMarkerPair(mpLineComment1, psz, NULL);
                }
                else if (i == 1)
                {
                        m_pti->SetMarkerPair(mpLineComment2, psz, NULL);
                }
                else
                {
                        break;
                }
        }
}

void CMyEditXmlLoader::loadBlockComments(IXMLDOMNode* pNode)
{
        CComPtr<IXMLDOMNodeList>pNodeList;
        pNode->get_childNodes(&pNodeList);
        
        long nNodes = 0;
        pNodeList->get_length(&nNodes);

        for (long i = 0; i < nNodes; i++)
        {
                CComPtr<IXMLDOMNode>pNode;
                pNodeList->get_item(i, &pNode);

                CComPtr<IXMLDOMNamedNodeMap>pAttributes;
                pNode->get_attributes(&pAttributes);
                
                CComPtr<IXMLDOMNode>nodeOn;
                pAttributes->getNamedItem(
                        _bstr_t(keySpecificBlockCommentsBlockCommentOn()),
                        &nodeOn);
                
                CComPtr<IXMLDOMNode>nodeOff;
                pAttributes->getNamedItem(
                        _bstr_t(keySpecificBlockCommentsBlockCommentOff()),
                        &nodeOff);

                _bstr_t textOn;
                nodeOn->get_text(textOn.GetAddress());
                _bstr_t textOff;
                nodeOff->get_text(textOff.GetAddress());

                LPCTSTR pszOn  = textOn;
                LPCTSTR pszOff = textOff;
                if ((pszOn == NULL) || (pszOff == NULL))
                {
                        reportError(IDS_E_STX_LOADER_INVALID_STX_FILE,
                                0,
                                m_pszFile);
                }

                if (i == 0)
                {
                        m_pti->SetMarkerPair(mpBlockComment1, pszOn, pszOff);
                }
                else if (i == 1)
                {
                        m_pti->SetMarkerPair(mpBlockComment2, pszOn, pszOff);
                }
                else
                {
                        break;
                }
        }
}

void CMyEditXmlLoader::loadBraceStrings(IXMLDOMNode* pNode)
{
        CComPtr<IXMLDOMNodeList>pNodeList;
        pNode->get_childNodes(&pNodeList);
        
        long nNodes = 0;
        pNodeList->get_length(&nNodes);

        for (long i = 0; i < nNodes; i++)
        {
                CComPtr<IXMLDOMNode>pNode;
                pNodeList->get_item(i, &pNode);

                CComPtr<IXMLDOMNamedNodeMap>pAttributes;
                pNode->get_attributes(&pAttributes);
                
                CComPtr<IXMLDOMNode>nodeOn;
                pAttributes->getNamedItem(
                        _bstr_t(keySpecificBraceStringsBraceStringOn()),
                        &nodeOn);
                
                CComPtr<IXMLDOMNode>nodeOff;
                pAttributes->getNamedItem(
                        _bstr_t(keySpecificBraceStringsBraceStringOff()),
                        &nodeOff);

                _bstr_t textOn;
                nodeOn->get_text(textOn.GetAddress());
                _bstr_t textOff;
                nodeOff->get_text(textOff.GetAddress());

                LPCTSTR pszOn  = textOn;
                LPCTSTR pszOff = textOff;
                if ((pszOn == NULL) || (pszOff == NULL))
                {
                        reportError(IDS_E_STX_LOADER_INVALID_STX_FILE,
                                0,
                                m_pszFile);
                }
                m_pti->AppendMarkerPair(mpBraceStrings, pszOn, pszOff);
        }
}

void CMyEditXmlLoader::loadQuotedStrings(IXMLDOMNode* pNode)
{
        CComPtr<IXMLDOMNodeList>pNodeList;
        pNode->get_childNodes(&pNodeList);
        
        long nNodes = 0;
        pNodeList->get_length(&nNodes);

        for (long i = 0; i < nNodes; i++)
        {
                CComPtr<IXMLDOMNode>pNode;
                pNodeList->get_item(i, &pNode);

                CComPtr<IXMLDOMNamedNodeMap>pAttributes;
                pNode->get_attributes(&pAttributes);
                
                CComPtr<IXMLDOMNode>nodeOn;
                pAttributes->getNamedItem(
                        _bstr_t(keySpecificQuotedStringsQuotedStringOn()),
                        &nodeOn);
                
                CComPtr<IXMLDOMNode>nodeOff;
                pAttributes->getNamedItem(
                        _bstr_t(keySpecificQuotedStringsQuotedStringOff()),
                        &nodeOff);

                _bstr_t textOn;
                nodeOn->get_text(textOn.GetAddress());
                _bstr_t textOff;
                nodeOff->get_text(textOff.GetAddress());

                LPCTSTR pszOn  = textOn;
                LPCTSTR pszOff = textOff;
                if ((pszOn == NULL) || (pszOff == NULL))
                {
                        reportError(IDS_E_STX_LOADER_INVALID_STX_FILE,
                                0,
                                m_pszFile);
                }

                if (i == 0)
                {
                        m_pti->SetMarkerPair(mpQuotedString1, pszOn, pszOff);
                }
                else if (i == 1)
                {
                        m_pti->SetMarkerPair(mpQuotedString2, pszOn, pszOff);
                }
                else
                {
                        break;
                }
        }
}
