#pragma once

#include <msxml2.h>
#include <atlcomcli.h>

/////////////////////////////////////////////////////////////////////////////
class CMyEditTypeInfo;
class CMyEditXmlLoader : public CObject
{
public:
        CMyEditXmlLoader();
        virtual        ~CMyEditXmlLoader();

public:
        void           loadSummary(LPCTSTR pszFile, CMyEditTypeInfo* pti);
        void           loadDetails(LPCTSTR pszFile, CMyEditTypeInfo* pti);

public:
        LPCTSTR        boolTRUE() const                                 { return _T("true"); }
        LPCTSTR        boolFALSE() const                                { return _T("false"); }

        LPCTSTR        keyLanguage() const                              { return _T("language"); }
        LPCTSTR        keyLanguageTitle() const                         { return _T("title"); }
        LPCTSTR        keyLanguageExtensions() const                    { return _T("extensions"); }
        LPCTSTR        keyLanguageDelimiters() const                    { return _T("delimiters"); }
        LPCTSTR        keyLanguageMatchCase() const                     { return _T("matchcase"); }
        LPCTSTR        keyLanguageEscape() const                        { return _T("escape"); }
        
        LPCTSTR        keySpecific() const                              { return _T("specific"); }
        LPCTSTR        keySpecificLineComments() const                  { return _T("linecomments"); }
        LPCTSTR        keySpecificLineCommentsLineComment() const       { return _T("linecomment"); }
        LPCTSTR        keySpecificLineCommentsLineCommentOn() const     { return _T("on"); }

        LPCTSTR        keySpecificBlockComments() const                 { return _T("blockcomments"); }
        LPCTSTR        keySpecificBlockCommentsBlockComment() const     { return _T("blockcomment"); }
        LPCTSTR        keySpecificBlockCommentsBlockCommentOn() const   { return _T("on"); }
        LPCTSTR        keySpecificBlockCommentsBlockCommentOff() const  { return _T("off"); }

        LPCTSTR        keySpecificQuotedStrings() const                 { return _T("quotedstrings"); }
        LPCTSTR        keySpecificQuotedStringsQuotedString() const     { return _T("quotedstring"); }
        LPCTSTR        keySpecificQuotedStringsQuotedStringOn() const   { return _T("on"); }
        LPCTSTR        keySpecificQuotedStringsQuotedStringOff() const  { return _T("off"); }

        LPCTSTR        keySpecificBraceStrings() const                  { return _T("bracestrings"); }
        LPCTSTR        keySpecificBraceStringsBraceString() const       { return _T("bracestring"); }
        LPCTSTR        keySpecificBraceStringsBraceStringOn() const     { return _T("on"); }
        LPCTSTR        keySpecificBraceStringsBraceStringOff() const    { return _T("off"); }

        LPCTSTR        keyKeywords() const                              { return _T("keywords"); }
        LPCTSTR        keyKeywordsClass() const                         { return _T("class"); }
        LPCTSTR        keyKeywordsClassName() const                     { return _T("name"); }
        LPCTSTR        keyKeywordsClassColor() const                    { return _T("color"); }
        LPCTSTR        keyKeywordsClassColorFormat() const              { return _T("#%x"); }
        LPCTSTR        keyKeywordsClassKeyword() const                  { return _T("keyword"); }

protected:
        LPCTSTR        m_pszFile; // ReportError׽m_strFile(LPCTSTR)m_strFile
        CString        m_strFile;
        CMyEditTypeInfo* m_pti;
        CComPtr<IXMLDOMDocument2>m_pDoc;

protected:
        void           reportError(UINT id);
        void           reportError(UINT id, int unused, ...);

        bool           isString(LPCTSTR psz1, LPCTSTR psz2);
        bool           isStringI(LPCTSTR psz1, LPCTSTR psz2);

        bool           valueBool(LPCTSTR pszString);
        COLORREF       valueColor(LPCTSTR pszString, COLORREF clrDef = CLR_INVALID);

        void           loadDocument();
        void           loadLanguage(IXMLDOMElement* pElement);
        void           loadSpecific(IXMLDOMNode* pNode);
        void           loadKeywords(IXMLDOMNode* pNode);
        void           loadKeyword(IXMLDOMNode* pNode, LONG nKeyClass);

        void           loadLineComments(IXMLDOMNode* pNode);
        void           loadBlockComments(IXMLDOMNode* pNode);
        void           loadBraceStrings(IXMLDOMNode* pNode);
        void           loadQuotedStrings(IXMLDOMNode* pNode);
};

/////////////////////////////////////////////////////////////////////////////
class CMyEditXmlLoaderException : public CException
{
        CString m_strMsg;
public:
        CMyEditXmlLoaderException(UINT ID)
                : CException(true)
        {
                m_strMsg.LoadString(ID);
        }
        CMyEditXmlLoaderException(LPCTSTR pszMessage)
                : CException(true)
        {
                m_strMsg = pszMessage;
        }
        virtual BOOL GetErrorMessage(LPTSTR lpszError,
                UINT nMaxError,
                PUINT pnHelpContext = NULL)
        {
                ASSERT(lpszError != NULL);
                ASSERT(nMaxError > 0);
                lstrcpyn(lpszError, (LPCTSTR)m_strMsg, nMaxError - 1);
                return true;
        }
};
